package com.muimi.mail;

import java.net.MalformedURLException;
import java.net.URL;

import org.eclipse.core.runtime.Platform;
import org.eclipse.jface.preference.IPreferenceStore;

/**
 * vOCPreferenceStoreɃANZXNX
 * @author Shinji Miyamoto
 */
public class PluginPreference {

	public final static String MAIL_DATA_PATH = "mail.data.path";

	public final static String MAIL_EDITOR_BROWZER_USE_EMBED =
		"mail.editor.browzer.user.embed";
	public final static String VAL_EMBED_USE = "use";
	public final static String VAL_EMBED_UNUSE = "unuse";

	public final static String MAIL_EDITOR_BROWZER_PATH =
		"mail.editor.browzer.path";

	public static void initializeDefaultPluginPreferences() {
		IPreferenceStore store = ps();

		try {
			store.setDefault(
				PluginPreference.MAIL_DATA_PATH,
				getDefaultMailDataPath());

			store.setDefault(
				PluginPreference.MAIL_EDITOR_BROWZER_USE_EMBED,
				PluginPreference.VAL_EMBED_UNUSE);

			store.setDefault(
				PluginPreference.MAIL_EDITOR_BROWZER_PATH,
				"C:\\Program Files\\Internet Explorer\\IEXPLORE.EXE");

		} catch (Exception e) {
			MailPlugin.logError("fail to initialized", e);
		}
	}

	private static String getDefaultMailDataPath() {
		//test
		//return "C:/tmp/mailstore";
		try {
			URL url =
				new URL(
					MailPlugin.getDefault().getDescriptor().getInstallURL(),
					"mailstore");
			url = Platform.asLocalURL(url);
			return url.getFile().toString();
		} catch (Exception e) {
			MailPlugin.logError("fail to calculate default data path", e);
			return "C:/tmp/mailstore";
		}
	}

	public static String getMailDataPath() {
		return ps().getString(MAIL_DATA_PATH);
	}

	public static boolean isUseEmbeddedBrowzer() {
		return ps().getString(MAIL_EDITOR_BROWZER_USE_EMBED).equals(
			VAL_EMBED_USE);
	}

	public static String getBworzerPath() {
		return ps().getString(MAIL_EDITOR_BROWZER_PATH);
	}

	private static IPreferenceStore ps() {
		return MailPlugin.getDefault().getPreferenceStore();
	}

}
