package com.muimi.mail;

import java.net.MalformedURLException;
import java.net.URL;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.program.Program;
import org.eclipse.swt.widgets.Display;

/**
 * vOC̃\[X֘A̒`
 * @author Shinji Miyamoto
 */
public class PluginResources {

	private static final URL INSTALL_URL = createInstallURL();

	public static final ImageDescriptor IMAGE_SEND
		= createImageDescriptor("icons/send.gif");
	public static final ImageDescriptor IMAGE_REPLY
		= createImageDescriptor("icons/reply.gif");
	public static final ImageDescriptor IMAGE_ATTACH
		= createImageDescriptor("icons/attach.gif");

	public static final ImageDescriptor IMAGE_FORWARD
		= createImageDescriptor("icons/ok.gif");
	public static final ImageDescriptor IMAGE_ACCOUNT
		= createImageDescriptor("icons/account.gif");
	public static final ImageDescriptor IMAGE_INBOX
		= createImageDescriptor("icons/inbox.gif");
	public static final ImageDescriptor IMAGE_OUTBOX
		= createImageDescriptor("icons/outbox.gif");
	public static final ImageDescriptor IMAGE_TRASH
		= createImageDescriptor("icons/trash.gif");
	public static final ImageDescriptor IMAGE_FOLDER
		= createImageDescriptor("icons/folder.gif");


	public static final Color COL_BG
		= createColor(255, 255, 255);
	public static final Color COL_RED
		= createColor(255, 0, 0);
	public static final Color COL_BLUE
		= createColor(0, 255, 0);
	public static Color COL_HYPERLINK 
		= createColor(0, 0, 255);
	public static Color COL_MAIL 
		= createColor(0, 128, 255);
	public static Color COL_ECLIPSE 
		= createColor(0, 128, 128);
	public static Color COL_REPLY 
		= createColor(0, 155, 80);


	//perpouse for main application
	//if not plugin context , return dummy url
	private static URL createInstallURL(){
		if(MailPlugin.getDefault() == null){
			try {
				return new URL("file://C/");
			} catch (MalformedURLException e) {
				throw new IllegalStateException();
			}
		}
		return MailPlugin.getDefault().getDescriptor().getInstallURL();
	}


	private static ImageDescriptor createImageDescriptor(String path) {
		try {
			URL url = new URL(INSTALL_URL, path);
			return ImageDescriptor.createFromURL(url);
		} catch (MalformedURLException e) {
		}
		return ImageDescriptor.getMissingImageDescriptor();
	}
	
	
	
	public static Image getImageByExtenstion(String ext){
		Program program = Program.findProgram(ext);
		if(program == null){
			return null;
		}
		ImageData data = program.getImageData();
		if(data == null){
			return null;
		}
		return new Image(Display.getDefault(), data);
	}
	
	
	public static Color createColor(int r, int g, int b){
		Display d = Display.getDefault();
		Color c = new Color(d, r, g, b);
		return c;
	}
	

	public static void freeResource(){
		//TODO 
	}		

}
