package com.muimi.mail.model;

import java.io.File;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Properties;

import javax.activation.DataHandler;
import javax.activation.FileDataSource;
import javax.mail.Folder;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Multipart;
import javax.mail.Session;
import javax.mail.Store;
import javax.mail.Transport;
import javax.mail.URLName;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;
import javax.mail.internet.MimeUtility;

import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.ui.IMemento;

import com.muimi.mail.MailPlugin;
import com.muimi.mail.ui.editor.MessageModel;
import com.muimi.mail.ui.editor.PortableFile;


/**
 * [AJEg
 * @author Shinji Miyamoto
 */
public class Account extends AccountData{


	private AccountRoot accountRoot;

	private List folders = new ArrayList();

	private static String ENCODING = "iso-2022-jp";


	private LocalFolder inbox;
	private LocalFolder outbox;
	private LocalFolder trash;


	private Store localStore;
	private Store remoteStore;




	public Account(){
		accountRoot = MailPlugin.getDefault().getAccountRoot();
	}



	private Account(IPreferenceStore prop){
		this();
		setPreference(prop);
		
		inbox = LocalFolder.createInBox(this);
		folders.add(inbox);
		
		outbox = LocalFolder.createOutBox(this);
		folders.add(outbox);
		
		trash = LocalFolder.createTrash(this);
		folders.add(trash);
	}


	public static Account createAccount(IPreferenceStore prop){
		Account account = new Account(prop);
		return account;
	}


	



//	/**
//	 * ̃AJEg̃[M܂B
//	 * M[INBOXɕۑ܂B
//	 */
//	public void receiveMail() throws MessagingException{
////TODO T[o[ォ烁[B
//		Store store = null;
//		Folder folder = null;
//		try{
////			store = getRemoteStore();
////			folder = store.getFolder("INBOX");
////			folder.open(Folder.READ_ONLY);
//
//			receiveMailInternal();
//			System.out.println("receive end" + Thread.currentThread().getName());
//
//		}finally{
////			closeFolder(folder);
////			closeStore(store);
//		}
//	}
//
//
//	private void receiveMailInternal(){
//		IRunnableWithProgress runnable = new IRunnableWithProgress() {
//			public void run(IProgressMonitor monitor)
//				throws InvocationTargetException, InterruptedException {
//
//				try {
//					monitor.beginTask("receive", 10);
//						
//					try {
//						Store store = getRemoteStore();
//						Folder folder = store.getFolder("INBOX");
//						
//						
////						System.out.println("count" + folder.getMessageCount());
////						
////						folder.addMessageCountListener(new MessageCountListener(){
////
////							public void messagesAdded(MessageCountEvent arg0) {
////								System.out.println("add");
////							}
////							public void messagesRemoved(MessageCountEvent arg0) {
////								// TODO ꂽ\bhEX^u
////								
////							}});
////						
////						folder.addConnectionListener(new ConnectionListener(){
////
////							public void opened(ConnectionEvent arg0) {
////								System.out.println("**open");
////							}
////
////							public void disconnected(ConnectionEvent arg0) {
////								System.out.println("**disconnected");
////							}
////
////							public void closed(ConnectionEvent arg0) {
////								System.out.println("**closed");
////							}});
//
//						folder.open(Folder.READ_ONLY);
//						
////						folder.close(true);
//
//					} catch (MessagingException e) {
//						throw new InvocationTargetException(e);
//					}
//
//				} finally {
//					System.out.println("<<<<<<<<<<<<");
//					monitor.done();
//				} 
//			}
//		};
//			
//		try {
//			MailPlugin.getWindow().run(true, true ,runnable);
//		} catch (InvocationTargetException e) {
//			e.printStackTrace();
//		} catch (InterruptedException e) {
//			System.out.println("canceled.");
//		}
//	}


	/**
	 * [𑗐M܂B
	 * @param model
	 * @throws MessagingException
	 */
	public void sendMail(MessageModel model) throws MessagingException {
		System.out.println(this);

		Session session = getRemoteSession();


		if(isPop3BeforeSmtp){
			Store store = session.getStore(getURLName());
			store.connect();
			store.close();
		}


		Message message = createMessageForSend(session, model);

		Transport.send(message);
		
		outbox.addMessage(message);
	}



	public Folder getFolder(String folderName) throws MessagingException{
		Store store = getLocalStore();
		return store.getFolder(folderName);
	}

	public Folder getRemoteFolder(String folderName) throws MessagingException{
		Store store = getRemoteStore();
		return store.getFolder(folderName);
	}

	public File getLocalFolderDir(String folderName){
		File root = new File(accountRoot.getMailDataPath());
		File account = new File(root, label);
		File folder = new File(account, folderName);
		return folder;
	}

	
	
	private Store getRemoteStore() throws MessagingException {
		if(remoteStore != null){
			if(remoteStore.isConnected()){
				return remoteStore;
			}
		}
		remoteStore = getRemoteSession().getStore(getURLName());	
		remoteStore.connect();//TODO CONNECT
		return remoteStore;
	}
	
	
	private Store getLocalStore() throws MessagingException{
		if(localStore != null){
			if(localStore.isConnected()){
				return localStore;
			}
		}
		localStore = getLocalSession().getStore(getURLName());
		localStore.connect();//TODO CONNECT
		return localStore;
	}
	

	
	public Session getRemoteSession(){
		Properties prop = System.getProperties();
		prop.setProperty("mail.smtp.host", smtpHost);
		prop.setProperty("jp.gr.java_conf.roadster.net.pop.offline","false");
		prop.setProperty("jp.gr.java_conf.roadster.net.pop.receiveImmediatery","true");

		if(isLeaveOnServerMessage()){
			prop.setProperty("jp.gr.java_conf.roadster.net.pop.leaveOnServer","true");
		}else{
System.out.println("LEAVE FALSE");
			prop.setProperty("jp.gr.java_conf.roadster.net.pop.leaveOnServer","false");
		}
		
		Session session = Session.getDefaultInstance(prop);
		session.setDebug(accountRoot.isDebug());
		return session;
	}
	
	public Session getLocalSession(){
		Properties prop = System.getProperties();
		prop.setProperty("jp.gr.java_conf.roadster.net.pop.offline","true");
		Session session = Session.getDefaultInstance(prop);
		session.setDebug(accountRoot.isDebug());
		return session;
	}
		
	
	
	private void closeStore(Store store){
		if(store != null){
			try {
				if(store.isConnected()){
					store.close();
				}
			} catch (MessagingException e) {
				e.printStackTrace();
			}
		}
	}
	
	private void closeFolder(Folder folder){
		if(folder != null){
			try {
				if(folder.isOpen()){
					folder.close(true);
				}
			} catch (MessagingException e) {
				e.printStackTrace();
			}
		}
	}
	
	private URLName getURLName(){
		URLName urlName = new URLName(
			"pop3://" +
			user +
			":" +
			password +
			"@" +
			pop3Host +
			"/" + 
			"?localstore=" +
			getLocalStorePath()
			);
		return urlName;
	}


	public String getLocalStorePath(){
		return accountRoot.getMailDataPath() + "/" + label;
	}


	public InternetAddress getUserInetAddress() {
		try {
			return new InternetAddress(userAddress, userName, ENCODING);
		} catch (UnsupportedEncodingException e) {
			MailPlugin.logError("unexpected error",e);
			throw new IllegalStateException();
		}
	}


	public String getEncoding(){
		return ENCODING;
	}



	private Message createMessageForSend(Session session, MessageModel model) throws MessagingException {
		MimeMessage mm = new MimeMessage(session);

		mm.setFrom(getUserInetAddress());
		mm.setRecipients(Message.RecipientType.TO, model.getTo());
		mm.setSubject(model.getSubject(), getEncoding());
		mm.setText(model.getContentText(), getEncoding());
		mm.setHeader("Content-Type", "text/plain");

		PortableFile[] attachs = model.getAttachments();
		if(attachs.length > 0){
			System.out.println("*****************ATTACH!!!!");
			Multipart mp = new MimeMultipart();
			
			MimeBodyPart textBody = new MimeBodyPart();
			textBody.setText(model.getContentText(), getEncoding());
			mp.addBodyPart(textBody);

			for(int i=0; i<attachs.length; i++){
				PortableFile attach = attachs[i];
				
				MimeBodyPart body = new MimeBodyPart();
				
				FileDataSource fds = new FileDataSource(attach.getLocalFile());
				body.setDataHandler(new DataHandler(fds));
				try {
					body.setFileName(MimeUtility.encodeWord(fds.getName()));
				} catch (UnsupportedEncodingException e) {
					e.printStackTrace();
				}
				mp.addBodyPart(body);
			}
			mm.setContent(mp);
		}

		return mm;
	}



	public MessageModel createNewMessageModel(){
		MessageModel model = new MessageModel(this);
		model.setFrom(getUserAddress().toString());
		return model;
	}




	public LocalFolder getInbox(){
		return inbox;
	}
	
	public LocalFolder getOutbox(){
		return outbox;
	}
	
	public LocalFolder getTrash(){
		return trash;
	}
	

	public LocalFolder[] getLocalFolders(){
		return (LocalFolder[])folders.toArray(new LocalFolder[0]);
	}
	
	public String getLabel(){
		return label;
	}
	



	public String toString(){
		return super.toString() + "\n"
			+ "label=" + label + "\n"
			+ "smtpHost=" + smtpHost + "\n"
			+ "pop3Host=" + pop3Host + "\n"
			+ "user=" + user + "\n"
			+ "password=" + password + "\n"
			+ "userAddress=" + userAddress + "\n"
			+ "userName=" + userName + "\n"
		;
	}



	public void persist(IMemento memento){
		super.persist(memento);

		for (Iterator iter = folders.iterator(); iter.hasNext();) {
			LocalFolder folder = (LocalFolder) iter.next();
			IMemento child = memento.createChild("folder");
			folder.persist(child);
		}

	}

	
	public void restore(IMemento memento){
		super.restore(memento);
		
		IMemento[] childs = memento.getChildren("folder");
		for (int i = 0; i < childs.length; i++) {
			LocalFolder folder = new LocalFolder(this);
			folder.restore(childs[i]);
			folders.add(folder);
			
			if(folder.isInBox()){
				inbox = folder;
			}else if(folder.isOutBox()){
				outbox = folder;
			}else if(folder.isTrash()){
				trash = folder;
			}
		}
	}
	
	
	
	
	
	/**
	 * for debug
	 */
	public void setTestData(){
		label = "hoge";
		user = "kabukin3";
		password = "3kabukin";
		pop3Host = "pop.mail.yahoo.co.jp";
		
		accountRoot = new AccountRoot();
	}
	
	
//	public void disconnect(){
//	}

//	public static void main(String[] args) throws Exception{
//		Account account = new Account();
//		account.setTestData();
//
////		account.receiveMail();
//
//		Message[] msgs = account.getLocalMessages("INBOX");
//		for(int i=0; i<msgs.length; i++){
//			System.out.println(msgs[i].getSubject());
//			//System.out.println(msgs[i].getContent().toString());
//		}
//		System.out.println("END");
//	}


}
