package com.muimi.mail.model;

import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.preference.PreferenceStore;
import org.eclipse.ui.IMemento;

/**
 * [AJEg̒lێNX
 * @author Shinji Miyamoto
 */
public class AccountData {

	public final static String KEY_LABEL = "label";
	public final static String KEY_SMTP_HOST = "smtp.host";
	public final static String KEY_POP3_HOST = "pop3.host";
	public final static String KEY_USER = "user";
	public final static String KEY_PASSWORD = "password";
	public final static String KEY_USER_ADDRESS = "user.address";
	public final static String KEY_USER_NAME = "user.name";
	public final static String KEY_POP3BEFORESMTP = "pop3beforesmtp";
	public final static String KEY_LEAVEONSERVERMESSAGE = "leaveonservermessage";


	String label = "hoge";
	String smtpHost;
	String pop3Host;
	String user;
	String password;
	String userAddress;
	String userName;
	boolean isPop3BeforeSmtp = true;
	boolean isLeaveOnServerMessage = true;








	public void setPreference(IPreferenceStore prop){
		label = prop.getString(KEY_LABEL);
		smtpHost = prop.getString(KEY_SMTP_HOST);
		pop3Host = prop.getString(KEY_POP3_HOST);
		user = prop.getString(KEY_USER);
		password = prop.getString(KEY_PASSWORD);
		userAddress = prop.getString(KEY_USER_ADDRESS);
		userName = prop.getString(KEY_USER_NAME);
		isPop3BeforeSmtp = prop.getBoolean(KEY_POP3BEFORESMTP);
		isLeaveOnServerMessage = prop.getBoolean(KEY_LEAVEONSERVERMESSAGE);
	}

	public IPreferenceStore asPreference(){
		PreferenceStore prop = new PreferenceStore();
		prop.setValue(KEY_LABEL, label);
		prop.setValue(KEY_SMTP_HOST, smtpHost);
		prop.setValue(KEY_POP3_HOST, pop3Host);
		prop.setValue(KEY_USER, user);
		prop.setValue(KEY_PASSWORD, password);
		prop.setValue(KEY_USER_ADDRESS, userAddress);
		prop.setValue(KEY_USER_NAME, userName);
		prop.setValue(KEY_POP3BEFORESMTP, isPop3BeforeSmtp);
		prop.setValue(KEY_LEAVEONSERVERMESSAGE, isLeaveOnServerMessage);
		return prop;
	}

	public void persist(IMemento memento){
		memento.putString(KEY_LABEL, label);
		memento.putString(KEY_SMTP_HOST, smtpHost);
		memento.putString(KEY_POP3_HOST, pop3Host);
		memento.putString(KEY_USER, user);
		memento.putString(KEY_PASSWORD, password);
		memento.putString(KEY_USER_ADDRESS, userAddress);
		memento.putString(KEY_USER_NAME, userName);

		setBoolean(memento, KEY_POP3BEFORESMTP, isPop3BeforeSmtp);
		setBoolean(memento, KEY_LEAVEONSERVERMESSAGE, isLeaveOnServerMessage);
	}

	
	public void restore(IMemento memento){
		label = memento.getString(KEY_LABEL);
		smtpHost = memento.getString(KEY_SMTP_HOST);
		pop3Host = memento.getString(KEY_POP3_HOST);
		user = memento.getString(KEY_USER);
		password = memento.getString(KEY_PASSWORD);
		userAddress = memento.getString(KEY_USER_ADDRESS);
		userName = memento.getString(KEY_USER_NAME);
		
		isPop3BeforeSmtp = getBoolean(memento, KEY_POP3BEFORESMTP);
		isLeaveOnServerMessage = getBoolean(memento, KEY_LEAVEONSERVERMESSAGE);
	}


	private void setBoolean(IMemento memento, String key, boolean value){
		if(value){
			memento.putString(key, "true");
		}else{
			memento.putString(key, "false");
		}
	}

	private boolean getBoolean(IMemento memento, String key){

		String value = memento.getString(key);
		if(value != null && value.equals("true")){
			return true;
		}else{
			return false;
		}
		
		
	}








	/**
	 * @return
	 */
	public boolean isLeaveOnServerMessage() {
		return isLeaveOnServerMessage;
	}

	/**
	 * @return
	 */
	public boolean isPop3BeforeSmtp() {
		return isPop3BeforeSmtp;
	}

	/**
	 * @return
	 */
	public String getLabel() {
		return label;
	}

	/**
	 * @return
	 */
	public String getPassword() {
		return password;
	}

	/**
	 * @return
	 */
	public String getPop3Host() {
		return pop3Host;
	}

	/**
	 * @return
	 */
	public String getSmtpHost() {
		return smtpHost;
	}

	/**
	 * @return
	 */
	public String getUser() {
		return user;
	}

	/**
	 * @return
	 */
	public String getUserAddress() {
		return userAddress;
	}

	/**
	 * @return
	 */
	public String getUserName() {
		return userName;
	}

	/**
	 * @param b
	 */
	public void setLeaveOnServerMessage(boolean b) {
		isLeaveOnServerMessage = b;
	}

	/**
	 * @param b
	 */
	public void setPop3BeforeSmtp(boolean b) {
		isPop3BeforeSmtp = b;
	}

	/**
	 * @param string
	 */
	public void setLabel(String string) {
		label = string;
	}

	/**
	 * @param string
	 */
	public void setPassword(String string) {
		password = string;
	}

	/**
	 * @param string
	 */
	public void setPop3Host(String string) {
		pop3Host = string;
	}

	/**
	 * @param string
	 */
	public void setSmtpHost(String string) {
		smtpHost = string;
	}

	/**
	 * @param string
	 */
	public void setUser(String string) {
		user = string;
	}

	/**
	 * @param string
	 */
	public void setUserAddress(String string) {
		userAddress = string;
	}

	/**
	 * @param string
	 */
	public void setUserName(String string) {
		userName = string;
	}

}
