package com.muimi.mail.ui;

import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.FileFieldEditor;
import org.eclipse.jface.preference.RadioGroupFieldEditor;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

import com.muimi.mail.MailPlugin;
import com.muimi.mail.PluginPreference;

/**
 * [GfB^̐ݒ
 * @author Shinji Miyamoto
 */
public class MailEditorPreference
	extends FieldEditorPreferencePage
	implements IWorkbenchPreferencePage {


	public MailEditorPreference() {
		super(GRID);
		setPreferenceStore(MailPlugin.getDefault().getPreferenceStore());
	}


	public void createFieldEditors() {

		RadioGroupFieldEditor selectBrowzerField
		= new RadioGroupFieldEditor(PluginPreference.MAIL_EDITOR_BROWZER_USE_EMBED,
			"Browzer",
			1,
			new String[][]{
				{"Embbed(Win32 only)", PluginPreference.VAL_EMBED_USE},
				{"External", PluginPreference.VAL_EMBED_UNUSE}
			},
			getFieldEditorParent(),
			true
		);
		addField(selectBrowzerField);
	
		FileFieldEditor browzerPathEditor = new FileFieldEditor(
				PluginPreference.MAIL_EDITOR_BROWZER_PATH,
				"External Browzer",
				getFieldEditorParent());
		addField(browzerPathEditor);
	}

	public void init(IWorkbench workbench) {
	}
}
