package com.muimi.mail.ui.editor;

import java.io.File;
import java.io.IOException;

import org.eclipse.jface.action.Action;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.ui.IEditorPart;

import com.muimi.mail.PluginResources;

/**
 * Ytt@CANV
 * @author Shinji Miyamoto
 */
public class AttachAction extends Action{

	private IEditorPart editor;

	public AttachAction(){
		setText("Attach");
		setToolTipText("Add Attach");
		setImageDescriptor(PluginResources.IMAGE_ATTACH);
	}


	public void run(){
		System.out.println("run AttachAction");

		FileDialog dialog = new FileDialog(Display.getDefault().getActiveShell(), SWT.OPEN);
		String fileName = dialog.open();
		if(fileName != null){
			File file = new File(fileName);
			try {
				PortableFile attach = new PortableFile(file);
				((MailEditor)editor).addAttach(attach);
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

	}

	public void setActiveEditor(IEditorPart editor){
		this.editor = editor;

		MessageModel messageModel = (MessageModel)editor.getEditorInput();
		if(messageModel.isNewMessage()){
			setEnabled(true);
		}else{
			setEnabled(false);
		}
	}
}
