package com.muimi.mail.ui.editor;

import java.io.FileOutputStream;
import java.io.OutputStream;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;

import com.muimi.mail.PluginResources;

/**
 * Ytt@C̃x
 * @author Shinji Miyamoto
 */
public class AttachLabel extends Composite{

	private PortableFile file;

	private Label textLabel;
	private Label imageLabel;

	private Menu popup;

	public AttachLabel(Composite parent, int style) {
		super(parent, style);
		setLayout(new FillLayout());
		
		popup = createMenu(parent);
	}


	private Menu createMenu(Composite parent){
		Menu menu = new Menu(parent.getShell(), SWT.POP_UP);
		MenuItem item = new MenuItem(menu, SWT.NULL);
		item.addSelectionListener(new SaveListener());
		item.setText("Ytt@Cۑ");
		return menu;
	}

	
	class SaveListener implements SelectionListener{

		public void widgetSelected(SelectionEvent e) {
			FileDialog dialog = new FileDialog(getShell(), SWT.SAVE);
			dialog.setText("ۑI");
			dialog.setFileName(file.getName());
			String targetName= dialog.open();
			//System.out.println(targetName);
			
			try {
				OutputStream out = new FileOutputStream(targetName);
				out.write(file.getData());
				out.close();
			} catch (Exception e1) {
				e1.printStackTrace();
			}
			

		}

		public void widgetDefaultSelected(SelectionEvent e) {			
		}

	}
	
	
	/**
	 * @return
	 */
	public PortableFile getFile() {
		return file;
	}

	/**
	 * @param file
	 */
	public void setFile(PortableFile file) {
		this.file = file;
		
		String fileName = file.getName();
		
		int pos = fileName.indexOf(".");
		if(pos != -1){
			String ext = fileName.substring(pos + 1);
			Image image = PluginResources.getImageByExtenstion(ext);
			if(image != null){
				Label imageLabel = new Label(this, SWT.NULL);
				imageLabel.setImage(image);
				inherit(imageLabel);
			}
		}


		textLabel = new Label(this, SWT.NULL);	
		textLabel.setText(fileName);
		inherit(textLabel);
	}



	private void inherit(Control control){
		control.setMenu(popup);
		control.setBackground(PluginResources.COL_BG);
	}

}
