package com.muimi.mail.ui.editor.content;

import org.eclipse.jface.text.Document;
import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.source.SourceViewer;
import org.eclipse.jface.text.source.VerticalRuler;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.VerifyKeyListener;
import org.eclipse.swt.events.VerifyEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;

import com.muimi.mail.ui.editor.MessageModel;

/**
 * [GfB^̖{̃GfB^
 * SourceViewerł̎(TODO 悤ƎvčĂr)
 * @author Shinji Miyamoto
 */
public class ContentEditor implements IContentEditor{

	private MessageModel messageModel;

	private SourceViewer viewer;

	public ContentEditor(MessageModel messageModel) {
		this.messageModel = messageModel;
	}

	public Control createContent(Composite parent, boolean readOnly) {
		Composite c = new Composite(parent, SWT.BORDER);
		c.setLayout(new FillLayout());

		int viewerStyle = SWT.V_SCROLL | (readOnly ? SWT.READ_ONLY : 0);
		viewer = new SourceViewer(c, new VerticalRuler(8), viewerStyle);
		viewer.configure(new ContentEditorConfiguration());



		viewer.appendVerifyKeyListener(new VerifyKeyListener() {
			public void verifyKey(VerifyEvent event) {


				if (event.stateMask == SWT.CTRL && event.character == ' ') {
					doAction(event, SourceViewer.CONTENTASSIST_PROPOSALS, false);

				} 
				
//				else if (event.stateMask == SWT.CTRL && event.character == 'c') {
//
//					doAction(event, SourceViewer.COPY, true);
//
//				} else if (event.stateMask == SWT.CTRL && event.character == 'v') {
//
//					doAction(event, SourceViewer.PASTE, true);
//				}

			}
		});



		IDocument document;
		if (messageModel != null) {
			document = new Document(messageModel.getContentText());
		} else {
			document = new Document();
		}
		viewer.setDocument(document);

		//return c;
		return c;
	}


	private void doAction(VerifyEvent event, int id, boolean doit) {
		if (viewer.canDoOperation(id))
			viewer.doOperation(id);
		event.doit = doit;
	}


	public void setText(String text) {
		viewer.getDocument().set(text);
	}

	public String getText() {
		return viewer.getDocument().get();
	}

}
