package com.muimi.mail.ui.editor.content;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.IRegion;
import org.eclipse.jface.text.ITextViewer;
import org.eclipse.jface.text.contentassist.CompletionProposal;
import org.eclipse.jface.text.contentassist.ICompletionProposal;
import org.eclipse.jface.text.contentassist.IContentAssistProcessor;
import org.eclipse.jface.text.contentassist.IContextInformation;
import org.eclipse.jface.text.contentassist.IContextInformationValidator;

public class EditorContentAssistantProcessor implements IContentAssistProcessor {

	public ICompletionProposal[] computeCompletionProposals(
		ITextViewer viewer,
		int documentOffset) {

		try {
			IDocument document = viewer.getDocument();
			IRegion range = document.getLineInformationOfOffset(documentOffset);

			int start = range.getOffset();
			String prefix = document.get(start, documentOffset - start);

			//O؂
			for(int i=prefix.length()-1; i>=0; i--){
				char c = prefix.charAt(i);
				if(c == ' ' || c == '@'){
					prefix = prefix.substring(i+1);
					start = start + i + 1;
					break;
				}
			}


			String[] completions = getCompletions(prefix);
			ICompletionProposal[] proposals =
				new ICompletionProposal[completions.length];

			for (int i = 0; i < proposals.length; i++) {
				String completion = completions[i];
				proposals[i] =
					new CompletionProposal(
						completion,
						start,
						documentOffset - start,
						completion.length());
			}

			return proposals;

		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

	public IContextInformation[] computeContextInformation(
		ITextViewer viewer,
		int documentOffset) {
		return null;
	}

	public char[] getCompletionProposalAutoActivationCharacters() {
		return new char[] { '.' };
	}

	public char[] getContextInformationAutoActivationCharacters() {
		return null;
	}

	public String getErrorMessage() {
		return null;
	}

	public IContextInformationValidator getContextInformationValidator() {
		return null;
	}





	private String[] getCompletions(String prefix) {

		String[] proposals = new String[]{"ɂ","낵肢܂"};

		List list = new ArrayList();
		for (int i = 0; i < proposals.length; i++) {
			String proposal = proposals[i];
			if (proposal.startsWith(prefix)) {
				list.add(proposal);
			}
		}
System.out.println(prefix + " " +list.size());
		return (String[]) list.toArray(new String[0]);

	}

}
