package com.muimi.mail.ui.editor.content;

import org.eclipse.jface.text.rules.*;

public class EnvRule implements IRule {
	private final IToken token;

	public EnvRule(IToken token) {
		this.token = token;
	}

	public IToken evaluate(ICharacterScanner scanner) {
		int c = scanner.read();
		if (c == '%') {
			for (;;) {
				c = scanner.read();
				if (c == '%') {
					break;
				} else if (
					c == ICharacterScanner.EOF
						|| Character.isWhitespace((char) c)) {
					scanner.unread();
					break;
				}
			}

			return token;
		}
		scanner.unread();
		return Token.UNDEFINED;
	}
}
