package com.muimi.mail.ui.editor.content;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.jface.text.TextAttribute;
import org.eclipse.jface.text.rules.IRule;
import org.eclipse.jface.text.rules.IToken;
import org.eclipse.jface.text.rules.RuleBasedScanner;
import org.eclipse.jface.text.rules.SingleLineRule;
import org.eclipse.jface.text.rules.Token;
import org.eclipse.jface.text.rules.WhitespaceRule;
import org.eclipse.jface.text.rules.WordRule;



public class MailScanner extends RuleBasedScanner {

	public MailScanner() {

		List rules = new ArrayList();

		IToken keywordToken 
			= new Token(new TextAttribute(Constants.COL_KEYWORD));
		IToken otherToken 
			= new Token(new TextAttribute(Constants.COL_DEFAULT));
		IToken urlToken 
			= new Token(new TextAttribute(Constants.COL_URL));
		IToken replyToken 
			= new Token(new TextAttribute(Constants.COL_REPLY));

		rules.add(new StartWordRule(">", replyToken));
		rules.add(new StartWordRule("", replyToken));
		
		rules.add(new UrlRule(urlToken));	
		
	
		IRule whitespaceRule = new WhitespaceRule(new WhitespaceDetector());
		rules.add(whitespaceRule);


		WordRule keywordRule = new WordRule(new WordDetector(), otherToken);
		String[] keywords = new String[]{"hoge","foo"};;
		for (int i = 0; i < keywords.length; i++) {
			keywordRule.addWord(keywords[i], keywordToken);
		}
		rules.add(keywordRule);


		setRules((IRule[])rules.toArray(new IRule[0]));

	}

}
