package com.muimi.mail.ui.editor.content;

import org.eclipse.jface.text.rules.*;

public class UrlRule implements IRule {
	private final IToken token;

	public UrlRule(IToken token) {
		this.token = token;
	}

	public IToken evaluate(ICharacterScanner scanner) {
		int c = scanner.read();

		if(!isMatch("http://", scanner)){
			scanner.unread();
			return Token.UNDEFINED;
		}

		for (;;) {
			c = scanner.read();
			if (c == '%') {
				break;
			} else if (
				c == ICharacterScanner.EOF
					|| Character.isWhitespace((char) c)) {
				scanner.unread();
				break;
			}
		}

		return token;
	}
	
	private boolean isMatch(String word, ICharacterScanner scanner){
		for(int i=0; i<word.length(); i++){
			int c = scanner.read();
			if( c != word.charAt(i) ){
				return false;
			}
		}
		return true;
	}
	
}
