/*
 * MessageIndex.java
 *
 * Copyright (C) 1998-2000 FreeBeans <freebeans@mub.biglobe.ne.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Copyright (C) 1998-2000N FreeBeans <freebeans@mub.biglobe.ne.jp>
 *
 * {vO̓t[E\tgEFAłBȂ́AFree Software Foundation 
 * \GNU ʌLgṕuo[WQv͂ȍ~̊eo[W
 * ̒炢ꂩIÃo[W߂ɏ]Ė{vO
 * ĔЕz܂͕ύX邱Ƃł܂B
 * {vO͗LpƂ͎v܂AЕzɂẮAsꐫyѓړIK
 * ɂĂ̈Öق̕ۏ؂܂߂āAȂۏ؂sȂ܂BڍׂɂĂ
 * GNU ʌLgpǂ݂B
 *
 * Ȃ́A{vOƈꏏGNU ʌLgp̎ʂ󂯎Ă
 * ͂łBłȂꍇ́AFree Software Foundation, Inc., 675 Mass Ave,
 * Cambridge, MA 02139, USA ֎莆ĂB
 */
package jp.gr.java_conf.roadster.net.pop;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FilenameFilter;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.io.Serializable;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import javax.mail.Flags;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.internet.InternetHeaders;

/**
 * bZ[Wt@CǗNX.
 * P̕fBNgɑ΂āAP̃CX^X݂.
 * P̕fBNgɑ΂āA POP3Folder CX^X
 * ݂ꍇɂÃNXŃt@Cւ̃ANZX𓯊.
 */
class MessageIndex {
	/**
	 * CfbNXt@C.
	 */
	private static final String INDEX_FILE_NAME = "folder.idx";
	
	/**
	 * f[^t@C̃TtBbNX.
	 */
	private static final String DATA_FILE_SUFFIX = ".dat";

	/**
	 * o̓obt@̃TCY.(=16KB)
	 */
	private static final int BUFFER_SIZE = 16 * 1024;
	
	/**
	 * CX^X.
	 * P̃fBNgɑ΂āAQȏ̃CX^X
	 * ݂Ȃ悤ɐ䂵Ă.
	 */
	private static Hashtable instances = new Hashtable();

	/**
	 * ۑpobNOEhXbh.
	 * SCX^X̃f[^AP̃obNOEhXbhŕۑ.
	 */
	private static SaverThread saverThread;

	/**
	 * f[^fBNg.
	 */
	private File dataDirectory;
	
	/**
	 * CfbNXt@C.
	 */
	private File indexFile;
	
	/**
	 * CfbNX{.
	 */
	private Vector elements;
	
	/**
	 * f[^LbVĂWeakHashMap IuWFNgB
	 * MessageIndexElementL[ɂāAInternetHeaders IuWFNgLbVĂB
	 */
	private static final Object HEADERS_MAP;
	
	/**
	 * f[^LbVĂWeakHashMap IuWFNgB
	 * MessageIndexElementL[ɂāAbyte[] IuWFNgicontentjLbVĂB
	 */
	private static final Object CONTENT_MAP;

	/**
	 * WeakHashMap  get \bhB
	 * WeakHashMap݂ȂJDK1.1 ł삷悤ɁAtNVgĂB
	 */
	private static final Method WEAKHASHMAP_GET_METHOD;
	
	/**
	 * WeakHashMap  put \bhB
	 * WeakHashMap݂ȂJDK1.1 ł삷悤ɁAtNVgĂB
	 */
	private static final Method WEAKHASHMAP_PUT_METHOD;
	
	// Java2ŁAWeakHashMapB
	// CX^X̃RXǵAJVMłP񂾂ƂȂB
	static {
		Object headersInstance = null;
		Object contentInstance = null;
		Method method_get = null;
		Method method_put = null;
		try {
			// WeakHashMap̃\bhtNVgĎ擾B
			final Class weakHashMapClass = Class.forName("java.util.WeakHashMap");
			headersInstance = weakHashMapClass.newInstance();
			contentInstance = weakHashMapClass.newInstance();
			
			final Class[] getParams = new Class[1];
			getParams[0] = Object.class;
			final Class[] putParams = new Class[2];
			putParams[0] = Object.class;
			putParams[1] = Object.class;
			
			method_get = weakHashMapClass.getMethod("get", getParams);
			method_put = weakHashMapClass.getMethod("put", putParams);
		} catch (ClassNotFoundException cnfe) {
			headersInstance = null;
			contentInstance = null;
			method_get = null;
			method_put = null;
		} catch (InstantiationException ie) {
			headersInstance = null;
			contentInstance = null;
			method_get = null;
			method_put = null;
		} catch (IllegalAccessException iae) {
			headersInstance = null;
			contentInstance = null;
			method_get = null;
			method_put = null;
		} catch (NoSuchMethodException nsme) {
			headersInstance = null;
			contentInstance = null;
			method_get = null;
			method_put = null;
		} finally {
			HEADERS_MAP = headersInstance;
			CONTENT_MAP = contentInstance;
			WEAKHASHMAP_GET_METHOD = method_get;
			WEAKHASHMAP_PUT_METHOD = method_put;
		}
	}

	/**
	 * w肳ꂽfBNg̃t@CǗ
	 * MessageIndex ̃CX^X쐬.
	 * ̃RXgN^ĂяoƂ͂łȂ.
	 * MessageIndex ̃CX^X́AgetInstance() \bhĂяoč쐬.
	 *
	 * @param	dataDirectory	ǗΏۂƂȂfBNg.
	 * @see	#getInstance(java.io.File)
	 */
	private MessageIndex(File dataDirectory) {
		try {
			this.dataDirectory = dataDirectory;
			indexFile = new File(dataDirectory, INDEX_FILE_NAME);
			load();
		} catch (IOException ioe) {
			ioe.printStackTrace();
		}
	}

	/**
	 * w肳ꂽfBNgɑΉ MessageIndex ̃CX^X𓾂.
	 *
	 * @param	dataDirectory	ǗΏۂƂȂfBNg.
	 */
	public static synchronized MessageIndex getInstance(File dataDirectory) {
		if (saverThread == null) {
			saverThread = new SaverThread();
			saverThread.start();
		}
		MessageIndex mfi = (MessageIndex) instances.get(dataDirectory);
		if (mfi == null) {
			mfi = new MessageIndex(dataDirectory);
			instances.put(dataDirectory, mfi);
		}
		return mfi;
	}

	/**
	 * tB[h elements .
	 */
	public synchronized void initElements() {
		if (elements == null) {
			elements = new Vector();
			elements.addElement(INDEX_FILE_NAME);	// 0Ԗڂ̗vf͎gȂ.
		} else {
			elements.setSize(1);
		}
	}
	
	/**
	 * w肳ꂽtH_ɏAw肳ꂽbZ[Wԍ POP3Message ̃CX^X쐬.
	 *
	 * @param	folder	POP3Folder ̃CX^X.
	 * @param	msgnum	bZ[Wԍ.
	 * @exception	java.lang.IndexOutOfBoundsException	msgnum ͈͂𒴂Ăꍇ.
	 */
	public synchronized POP3Message createMessage(POP3Folder folder, int msgnum) throws MessagingException {
		POP3Message message = new POP3Message(folder, msgnum);
		message.setInternalID(elements.elementAt(msgnum));
		return message;
	}
	
	/**
	 * w肳ꂽbZ[WɑΉ郁bZ[Wf[^̓̓Xg[𓾂.
	 *
	 * @param	message	bZ[W.
	 * @return	̓Xg[.
	 * @exception	java.io.IOException	G[ꍇ.
	 */
	private synchronized InputStream getInputStream(POP3Message message) throws IOException {
		MessageIndexElement mie = (MessageIndexElement) message.getInternalID();
		return new BufferedInputStream(mie.getInputStream(dataDirectory), BUFFER_SIZE);
	}

	/**
	 * w肳ꂽbZ[WInternetHeadersԂB
	 * Java2ł̓fBXNh^n炷߂ɁAǂݍ񂾃f[^LbVB
	 * LbV̓[NȂ悤ɁAWeakHashMapgĂ邽߁AJDK1.1ł̓LbVȂB
	 * JDK1.1ł́AɐVIuWFNgnewB
	 *
	 * @param	message	bZ[WB
	 * @return	InternetHeaders
	 * @throws	javax.mail.MessagingException	G[ꍇB
	 */
	public synchronized InternetHeaders getHeaders(POP3Message message) throws MessagingException {
		InternetHeaders ret = null;
		MessageIndexElement mie = (MessageIndexElement) message.getInternalID();
		try {
			if (CONTENT_MAP != null) {
				Object[] param = new Object[1];
				param[0] = mie;
				synchronized (HEADERS_MAP) {
					Object obj = WEAKHASHMAP_GET_METHOD.invoke(HEADERS_MAP, param);
					ret = (InternetHeaders) obj;
				}
			}
			if (ret == null) {	// LbVĂȂꍇAVɓǂ݂ށB
				InputStream is = getInputStream(message);
				ret = new InternetHeaders(is);
				is.close();
				if (HEADERS_MAP != null) {	// ǂ݂񂾌ʂLbVB
					Object[] params = new Object[2];
					params[0] = mie;
					params[1] = ret;
					synchronized (HEADERS_MAP) {
						WEAKHASHMAP_PUT_METHOD.invoke(HEADERS_MAP, params);
					}
				}
			}
		} catch (IOException ioe) {
			throw new MessagingException("IOException", ioe);
		} catch (IllegalAccessException iae) {
			throw new MessagingException("IllegalAccessException", iae);
		} catch (InvocationTargetException ite) {
			Throwable t = ite.getTargetException();
			if (t instanceof Error) {
				throw (Error) t;	// G[͂̂܂ܓB
			} else if (t instanceof Exception) {
				throw new MessagingException("Exception", (Exception) t);
			}
		}
		return ret;
	}

	/**
	 * w肳ꂽbZ[Wcontent\ byte[] ԂB
	 * Java2ł̓fBXNh^n炷߂ɁAǂݍ񂾃f[^LbVB
	 * LbV̓[NȂ悤ɁAWeakHashMapgĂ邽߁AJDK1.1ł̓LbVȂB
	 * JDK1.1ł́AɐVIuWFNgnewB
	 *
	 * @param	message	bZ[WB
	 * @return	content\byte[]
	 * @throws	javax.mail.MessagingException	G[ꍇB
	 */
	public synchronized byte[] getContentBytes(POP3Message message) throws MessagingException {
		byte[] ret = null;
		MessageIndexElement mie = (MessageIndexElement) message.getInternalID();
		try {
			if (CONTENT_MAP != null) {
				Object[] param = new Object[1];
				param[0] = mie;
				synchronized (CONTENT_MAP) {
					Object obj = WEAKHASHMAP_GET_METHOD.invoke(CONTENT_MAP, param);
					ret = (byte[]) obj;
				}
			}
			if (ret == null) {	// LbVĂȂꍇAVɓǂ݂ށB
				InputStream is = getInputStream(message);
				InternetHeaders headers = new InternetHeaders(is);
				ByteArrayOutputStream baos = new ByteArrayOutputStream();
				byte[] buff = new byte[16 * 1024];
				int len;
				while ((len = is.read(buff)) != -1) {
					baos.write(buff, 0, len);
				}
				is.close();
				baos.close();
				ret = baos.toByteArray();
				if (CONTENT_MAP != null) {	// ǂ݂񂾌ʂLbVB
					Object[] params = new Object[2];
					params[0] = mie;
					params[1] = ret;
					synchronized (CONTENT_MAP) {
						WEAKHASHMAP_PUT_METHOD.invoke(CONTENT_MAP, params);
					}
				}
			}
		} catch (IOException ioe) {
			throw new MessagingException("IOException", ioe);
		} catch (IllegalAccessException iae) {
			throw new MessagingException("IllegalAccessException", iae);
		} catch (InvocationTargetException ite) {
			Throwable t = ite.getTargetException();
			if (t instanceof Error) {
				throw (Error) t;	// G[͂̂܂ܓB
			} else if (t instanceof Exception) {
				throw new MessagingException("Exception", (Exception) t);
			}
		}
		return ret;
	}
	
	/**
	 * bZ[WCfbNXɒǉ.
	 * eMessageisExpunged()trueԂꍇɂ́ÃbZ[W̓XLbvB
	 *
	 * @param	msgs	ǉ郁bZ[W̔z.
	 *                  bZ[Wԍ͖AKɒǉ.
	 */
	public synchronized void append(Message msgs[]) {
		for (int i = 0; i < msgs.length; ++i) {
			try {
				Message message = msgs[i];
				if (! message.isExpunged()) {
					File file = createMessageFile();
					BufferedOutputStream bos = new BufferedOutputStream(new FileOutputStream(file), BUFFER_SIZE);
					message.writeTo(bos);
					bos.close();

					MessageIndexElement mie = new MessageIndexElement();
					mie.setFileName(file.getName());
					mie.setFlags(message.getFlags());
					elements.addElement(mie);
					saverThread.enqueue(this);
				}
			} catch (IOException ioe) {
				ioe.printStackTrace();
			} catch (MessagingException me) {
				me.printStackTrace();
			}
		}
	}
	
	/**
	 * w肳ꂽbZ[WɑΉf[^t@C폜.
	 *
	 * @param	msgs	폜郁bZ[W.
	 */
	public synchronized void remove(POP3Message msgs[]) {
		Vector removeElements = new Vector();
		for (int i = 0; i < msgs.length; ++i) {
			MessageIndexElement elem = (MessageIndexElement) msgs[i].getInternalID();
			elem.delete(dataDirectory);
			removeElements.addElement(elem);
		}
		Enumeration e = removeElements.elements();
		while (e.hasMoreElements()) {
			elements.removeElement(e.nextElement());
		}
		saverThread.enqueue(this);
	}
	
	/**
	 * ׂẴbZ[Wt@C폜.
	 * fBNgz̑SẴt@C폜A
	 *
	 * @return	폜ɐꍇ true.
	 */
	public synchronized boolean removeAll() {
		initElements();
		String files[] = dataDirectory.list(
			new FilenameFilter() {
				public boolean accept(File dir, String name) {
					File file = new File(dir, name);
					if (file.isFile()) {
						return true;
					} else {
						return false;
					}
				}
			});
		boolean result = true;
		for (int i = 0; i < files.length; ++i) {
			File file = new File(dataDirectory, files[i]);
			if (! file.delete()) {
				result = false;
			}
		}
		return result;
	}
	
	/**
	 * bZ[W𓾂.
	 *
	 * @return	bZ[W.
	 */
	public synchronized int getCount() {
		return elements.size() - 1;
	}
	
	/**
	 * CfbNXt@Cۑ.
	 */
	private synchronized void save() throws IOException {
		if (elements.size() > 1 || indexFile.exists()) {
			FileOutputStream   fos = new FileOutputStream(indexFile);
			ObjectOutputStream oos = new ObjectOutputStream(new BufferedOutputStream(fos, BUFFER_SIZE));
			oos.writeObject(elements);
			oos.close();
		}
	}
	
	/**
	 * SCX^X̃CfbNXۑ.
	 *
	 * @exception	java.io.IOException	G[ꍇ.
	 */
	static synchronized void saveAll() throws IOException {
		if (saverThread != null) {
			saverThread.saveAllIndexes();
		}
	}
	
	/**
	 * CfbNXt@Cǂݍ.
	 * ȑO̓eׂ͂Ĕj.
	 *
	 * @exception	java.io.IOException	G[ꍇ.
	 */
	private synchronized void load() throws IOException {
		initElements();
		try {
			FileInputStream   fis = new FileInputStream(indexFile);
			ObjectInputStream ois = new ObjectInputStream(new BufferedInputStream(fis, BUFFER_SIZE));
			elements = (Vector) ois.readObject();
			ois.close();
		} catch (FileNotFoundException fnfe) {
			recoverIndex();
		} catch (ClassNotFoundException cnfe) {
			recoverIndex();
		}
	}

	public synchronized void reload() throws IOException {
		load();
	}
	
	/**
	 * CfbNXt@CtȂꍇ̏s.
	 */
	private void recoverIndex() throws IOException {
		initElements();
		if (dataDirectory.exists()) {
			String files[] = dataDirectory.list(
				new FilenameFilter() {
					public boolean accept(File dir, String name) {
						if (name.endsWith(DATA_FILE_SUFFIX) && ! name.equals(POP3Store.UIDL_FILENAME)) {
							return true;
						}
						return false;
					}
				});
			if (files != null) {
				for (int i = 0; i < files.length; ++i) {
					MessageIndexElement mie = new MessageIndexElement();
					mie.setFileName(files[i]);
					elements.addElement(mie);
				}
			}
			if ( elements.size() > 1) {
				saverThread.enqueue(this);
			}
		}
	}
	
	/**
	 * bZ[Wt@CIuWFNg쐬.
	 * bZ[Wt@ĆAf[^fBNgzŃj[NƂȂ.
	 *
	 * @return	fBNgzŃj[NƂȂt@C.
	 */
	protected synchronized File createMessageFile() {
		long currentTime = System.currentTimeMillis();
		File file = null;
		do {
			file = new File(dataDirectory, Long.toHexString(currentTime) + DATA_FILE_SUFFIX);
			currentTime++;
		} while (file.exists());

		return file;
	}
	
	/**
	 * w肳ꂽbZ[WɃtOݒ肷.
	 *
	 * @param	message	bZ[W.
	 * @param	flags	tO.
	 */
	public synchronized void setFlags(POP3Message message, Flags flags) {
		MessageIndexElement elem = (MessageIndexElement) message.getInternalID();
		elem.setFlags(flags);
		saverThread.enqueue(this);
	}
	
	/**
	 * w肳ꂽbZ[W̃tO𓾂.
	 *
	 * @param	message	bZ[W.
	 * @return	tO.
	 */
	public synchronized Flags getFlags(POP3Message message) {
		MessageIndexElement elem = (MessageIndexElement) message.getInternalID();
		return elem.getFlags();
	}
	
	/**
	 * VKbZ[W̐𓾂.
	 *
	 * @return	VKbZ[W̐.
	 */
	public synchronized int getNewMessageCount() {
		int count = 0;
		for (int i = 1; i < elements.size(); ++i) {
			MessageIndexElement elem = (MessageIndexElement) elements.elementAt(i);
			if (elem.getFlags().contains(Flags.Flag.RECENT)) {
				count++;
			}
		}
		return count;
	}
	
	/**
	 * RECENTtONAB
	 */
	synchronized void clearRecentFlag() {
		for (int i = 1; i < elements.size(); ++i) {
			MessageIndexElement elem = (MessageIndexElement) elements.elementAt(i);
			elem.removeFlag(Flags.Flag.RECENT);
		}
		saverThread.enqueue(this);
	}
	
	/**
	 * ǃbZ[W̐𓾂.
	 *
	 * @return	ǃbZ[W̐.
	 */
	public synchronized int getUnreadMessageCount() {
		int count = 0;
		for (int i = 1; i < elements.size(); ++i) {
			MessageIndexElement elem = (MessageIndexElement) elements.elementAt(i);
			if (! elem.getFlags().contains(Flags.Flag.SEEN)) {
				count++;
			}
		}
		return count;
	}
	
	/**
	 * CfbNXt@CIɕۑXbh.
	 */
	static class SaverThread extends Thread {
		/**
		 * ۑ҂L[.
		 * CfbNXʂɕۑȂ悤ɐ䂷.
		 */
		private Vector waitingQueue = new Vector();
		
		/**
		 * obNOEhŃCfbNXt@Cۑ
		 * Xbh쐬.
		 * ̃Xbh͗Dx NORM_PRIORITY + 1 daemonƂē삷.
		 */
		SaverThread() {
			setDaemon(true);
			setPriority(Thread.NORM_PRIORITY + 1);
		}
		
		/**
		 * ۑpΏۂƂȂ MessageIndex ҂sɒǉ.
		 * ҂sɎw肳ꂽ MessageIndex ̃CX^X݂Ăꍇ
		 * ʂȕۑ邽߉Ƀ^[.
		 *
		 * @param	index	ۑΏۂƂȂMessageIndex.
		 */
		void enqueue(MessageIndex index) {
			synchronized (waitingQueue) {
				if (! waitingQueue.contains(index)) {
					waitingQueue.addElement(index);
					waitingQueue.notify();
				}
			}
		}
		
		/**
		 * ҂s̃CfbNXׂĕۑ.
		 * ۑ삪_ŁA҂sׂ͂ăNA.
		 *
		 * @exception	java.io.IOException	G[ꍇ.
		 */
		void saveAllIndexes() throws IOException {
			synchronized (waitingQueue) {
				Enumeration e = waitingQueue.elements();
				while (e.hasMoreElements()) {
					MessageIndex index = (MessageIndex) e.nextElement();
					index.save();
				}
				waitingQueue.removeAllElements();
			}
		}
		
		/**
		 * ҂sɓꂽMessageIndexۑ.
		 */
		public void run() {
			try {
				while (true) {
					MessageIndex index = null;
					synchronized (waitingQueue) {
						while (waitingQueue.isEmpty()) {
							waitingQueue.wait();
						}
						index = (MessageIndex)waitingQueue.firstElement();
						waitingQueue.removeElement(index);
					}
					if (index != null) {
						try {
							index.save();
						} catch (IOException ioe) {
							ioe.printStackTrace();
						}
					}
				}
			} catch (InterruptedException ie) {
				ie.printStackTrace();
			}
		}
	}
}

/**
 * bZ[Wt@CƃtOǗNX.
 * P̃bZ[Wt@Cɑ΂ĂPCX^X쐬.
 * ̃NX̓t@CɃVACY邽߁AύXɂ
 * ݊Ɋւ钍ӂKv.
 *
 * @author FreeBeans &lt;<A HREF="mailto:freebeans@mub.biglobe.ne.jp">mailto:freebeans@mub.biglobe.ne.jp</A>&gt;
 * @version 0.8.6
 */
class MessageIndexElement implements Serializable {
	/**
	 * VAo[Wԍ.ύXȂ.
	 */
	static final long serialVersionUID = -8416233115769537346L;

	/**
	 * bZ[Wt@C̖O.
	 * tH_l[ꂽۂ̏ȒPɂ邽߁AfBNg͊܂܂Ȃ.
	 */
	private String filename;
	
	/**
	 * bZ[W Flags.
	 *  Flags  Serializable ł͂Ȃ̂ŁA
	 * readObject()/writeObject() \bhŃVACYĂ.
	 */
	private transient Flags flags = new Flags();
	
	/**
	 * tOۑ邽߂̒萔Q.
	 * readObject()/writeObject() ŎgpĂ.
	 */
	private static final int ANSWERED_BIT =  1;
	private static final int DELETED_BIT  =  2;
	private static final int DRAFT_BIT    =  4;
	private static final int FLAGGED_BIT  =  8;
	private static final int RECENT_BIT   = 16;
	private static final int SEEN_BIT     = 32;
	private static final int USER_BIT     = 64;
	
	/**
	 * @serial	VXetO.
	 */
	private int systemFlags;
	
	/**
	 * @serial	[UtO.
	 */
	private String[] userFlags;
	
	/**
	 * ȂRXgN^.
	 */
	public MessageIndexElement() {
	}
	
	/**
	 * w肳ꂽt@CbZ[Wt@CƂ
	 * MessageIndexElement ̃CX^X쐬.
	 */
	public MessageIndexElement(String filename) {
		this.filename = filename;
	}
	
	/**
	 * t@Cݒ肷.
	 *
	 * @param	filename	t@C.
	 */
	public synchronized void setFileName(String filename) {
		this.filename = filename;
	}
	
	/**
	 * t@C𓾂.
	 *
	 * @return	t@C.
	 */
	public synchronized String getFileName() {
		return filename;
	}
	
	/**
	 * Flags ݒ肷.
	 *
	 * @param	flags
	 */
	public synchronized void setFlags(Flags flags) {
		this.flags = (Flags) flags.clone();
	}
	
	/**
	 * w肳ꂽFlag菜B
	 */
	public synchronized void removeFlag(Flags.Flag flag) {
		this.flags.remove(flag);
	}
	
	/**
	 * tOIuWFNg𓾂.
	 *
	 * @return	tOIuWFNg.
	 */
	public synchronized Flags getFlags() {
		return (Flags) flags.clone();
	}
	
	/**
	 * bZ[Wt@C̓̓Xg[𓾂.
	 *
	 * @param	directory	t@C݂̑fBNg.
	 * @return	̓Xg[.
	 * @exception	java.io.IOException	G[ꍇ.
	 */
	public synchronized InputStream getInputStream(File directory) throws IOException {
		return new FileInputStream(new File(directory, getFileName()));
		// FileNotFoundException  catch āA_~[f[^͂
		// InputStream Ԃ悤ɂ邩H
	}
	
	/**
	 * bZ[Wt@Cւ̏o̓Xg[𓾂.
	 *
	 * @param	directory	t@C݂̑fBNg.
	 * @return	o̓Xg[.
	 * @exception	java.io.IOException	G[ꍇ.
	 */
	public synchronized OutputStream getOutputStream(File directory) throws IOException {
		return new FileOutputStream(new File(directory, getFileName()));
	}
	
	/**
	 * bZ[Wt@C폜.
	 *
	 * @param	directory	t@C݂̑fBNg.
	 * @return	폜ɐꍇ true.
	 */
	public synchronized boolean delete(File directory) {
		File file = new File(directory, getFileName());
		return file.delete();
	}
	
	/**
	 * IuWFNg̓eXg[ǂݍ.
	 *
	 * @param	stream	̓Xg[.
	 * @exception	java.io.IOException	G[ꍇ.
	 * @exception	java.io.ClassNotFoundException	G[ꍇ.
	 */
	private void readObject(ObjectInputStream stream) throws IOException, ClassNotFoundException {
		stream.defaultReadObject();
		flags = new Flags();
		// ǂݍ񂾏ɁAflags tB[h.
		if ((systemFlags & ANSWERED_BIT) != 0) {
			flags.add(Flags.Flag.ANSWERED);
		}
		if ((systemFlags & DELETED_BIT) != 0) {
			flags.add(Flags.Flag.DELETED);
		}
		if ((systemFlags & DRAFT_BIT) != 0) {
			flags.add(Flags.Flag.DRAFT);
		}
		if ((systemFlags & FLAGGED_BIT) != 0) {
			flags.add(Flags.Flag.FLAGGED);
		}
		if ((systemFlags & RECENT_BIT) != 0) {
			flags.add(Flags.Flag.RECENT);
		}
		if ((systemFlags & SEEN_BIT) != 0) {
			flags.add(Flags.Flag.SEEN);
		}
		if ((systemFlags & USER_BIT) != 0) {
			flags.add(Flags.Flag.USER);
		}
		if (userFlags != null) {
			for (int i = 0; i < userFlags.length; ++i) {
				flags.add(userFlags[i]);
			}
		}
	}
	
	/**
	 * IuWFNg̓eXg[ɏo͂.
	 */
	private void writeObject(ObjectOutputStream stream) throws IOException {
		// VXetOo͂.
		systemFlags = 0;
		if (flags != null) {
			Flags.Flag flgs[] = flags.getSystemFlags();
			for (int i = 0; i < flgs.length; ++i) {
				if (flgs[i] == Flags.Flag.ANSWERED) {
					systemFlags |= ANSWERED_BIT;
				} else if (flgs[i] == Flags.Flag.DELETED) {
					systemFlags |= DELETED_BIT;
				} else if (flgs[i] == Flags.Flag.DRAFT) {
					systemFlags |= DRAFT_BIT;
				} else if (flgs[i] == Flags.Flag.FLAGGED) {
					systemFlags |= FLAGGED_BIT;
				} else if (flgs[i] == Flags.Flag.RECENT) {
					systemFlags |= RECENT_BIT;
				} else if (flgs[i] == Flags.Flag.SEEN) {
					systemFlags |= SEEN_BIT;
				} else if (flgs[i] == Flags.Flag.USER) {
					systemFlags |= USER_BIT;
				}
			}
		}
		
		// [UtOo͂.
		userFlags = flags.getUserFlags();
		stream.defaultWriteObject();
	}
}
