/**
 * POP3Client.java
 *
 * Copyright (C) 1998-2000 FreeBeans <freebeans@mub.biglobe.ne.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Copyright (C) 1998-2000N FreeBeans <freebeans@mub.biglobe.ne.jp>
 *
 * {vO̓t[E\tgEFAłBȂ́AFree Software Foundation 
 * \GNU ʌLgṕuo[WQv͂ȍ~̊eo[W
 * ̒炢ꂩIÃo[W߂ɏ]Ė{vO
 * ĔЕz܂͕ύX邱Ƃł܂B
 * {vO͗LpƂ͎v܂AЕzɂẮAsꐫyѓړIK
 * ɂĂ̈Öق̕ۏ؂܂߂āAȂۏ؂sȂ܂BڍׂɂĂ
 * GNU ʌLgpǂ݂B
 *
 * Ȃ́A{vOƈꏏGNU ʌLgp̎ʂ󂯎Ă
 * ͂łBłȂꍇ́AFree Software Foundation, Inc., 675 Mass Ave,
 * Cambridge, MA 02139, USA ֎莆ĂB
 */

package jp.gr.java_conf.roadster.net.pop;

import java.io.EOFException;
import java.io.InterruptedIOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.IOException;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.OutputStream;
import java.io.PushbackInputStream;
import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.net.Socket;
import java.net.SocketException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.StringTokenizer;
import java.util.Vector;

/**
 * POP3̃NCAgƂē삷NX.
 * POP3T[oƒʐMAbZ[W̎Ms.<BR>
 * ̃NX́Ajavax.mail.* pbP[WĂAgp\ł.
 * <BR>
 * T[oƂ̒ʐM菇́Aȉ̂悤ɂȂ.<BR>
 * <OL>
 * <LI>POP3ClientNX̃CX^X쐬AK؂ȃp[^
 * .<BR>
 * <UL><CODE>
 *  POP3Client pc = new POP3Client();<BR>
 *  pc.setHost("pop3.host.ne.jp");<BR>
 *  pc.setUser("user");<BR>
 *  pc.setPassword("password");<BR>
 *  pc.setAuthorizationMode(POP3Client.APOP_AUTHORIZATION);<BR>
 * </CODE></UL>
 * <LI>T[oɐڑ.<BR>
 *   <UL><CODE>
 *    pc.connect();<BR>
 *   </CODE></UL>
 * <LI>bZ[W̐擾.<BR>
 *   <UL><CODE>
 *    int count = pc.getMessageCount();<BR>
 *   </CODE></UL>
 * <LI>bZ[WM邽߂̓̓Xg[擾.<BR>
 *   <UL><CODE>
 *    InputStream ins = pc.retrieve(i); // i ̓CfbNX.<BR>
 *    while ((c = ins.read()) != -1) {
 *    <UL>
 *       // ǂݍ񂾓eɑ΂鏈.
 *    </UL>
 *    }<BR>
 *    ins.close();<BR>
 *   </CODE></UL>
 * <LI>Mς݂̃bZ[W폜.
 *   <UL><CODE>
 *    pc.delete(i); // i ̓CfbNX.<BR>
 *   </CODE></UL>
 * <LI>T[oƂ̐ڑؒf.<BR>
 *   <UL><CODE>
 *    pc.disconnect();<BR>
 *   </CODE></UL>
 * </OL>
 *
 * ڑT[o͈ȉ̎dl𖞂Ă邱ƂOƂĂ.<BR>
 * <OL>
 *  <LI>TCP/IPڑmAs̃X|X(greeting)AĂ邱.
 *  <LI>USERR}hAPASSR}hŃOCł邱.<BR>
 *      ܂́AAPOPT|[gĂ邱.
 *  <LI>LIST R}hŕԂeAȉ̌`ɂȂĂ邱.<BR>
 *      +OK ...<BR>
 *      1 203[CRLF]<BR>
 *      2 345[CRLF]<BR>
 *      ()<BR>
 *      .[CRLF]<BR>
 *  <LI>eR}hɑ΂郌X|Xs̒A512 oCgȉł邱.<BR>
 *      ARETR R}hɑ΂Qsڈȍ~̉ɂẮA̐͂Ȃ.
 * </OL>
 *
 */
public class POP3Client implements Serializable {
	/**
	 * VAo[Wԍ.
	 */
	static final long serialVersionUID = -3928372169782263062L;
	
	/**
	 * Xe[^Xs̍ő咷( = 512oCg).
	 * AbZ[W{ɂ͂̐͂Ȃ.
	 */
	private static final int MAX_LINE_LENGTH = 512;

	/**
	 * R}h^X|X̕GR[h.
	 */
	private static final String ENCODE = "8859_1";

	/**
	 * ftHgPOP|[g(=110)
	 */
	protected static final int DEFAULT_POP3_PORT = 110;

	/**
	 * CRR[h.
	 */
	protected static final byte CR = 0x0d;
	
	/**
	 * LFR[h.
	 */
	protected static final byte LF = 0x0a;

	/**
	 * USER R}h.
	 */
	protected static final String COMMAND_USER = "USER";
	
	/**
	 * PASS R}h.
	 */
	protected static final String COMMAND_PASS = "PASS";
	
	/**
	 * QUIT R}h.
	 */
	protected static final String COMMAND_QUIT = "QUIT";

	/**
	 * STAT R}h.
	 */
	protected static final String COMMAND_STAT = "STAT";

	/**
	 * LIST R}h.
	 */
	protected static final String COMMAND_LIST = "LIST";
	
	/**
	 * RETR R}h.
	 */
	protected static final String COMMAND_RETR = "RETR";
	
	/**
	 * DELE R}h.
	 */
	protected static final String COMMAND_DELE = "DELE";
	
	/**
	 * NOOP R}h.
	 */
	protected static final String COMMAND_NOOP = "NOOP";
	
	/**
	 * RSET R}h.
	 */
	protected static final String COMMAND_RSET = "RSET";
	
	/**
	 * APOP R}h.
	 */
	protected static final String COMMAND_APOP = "APOP";
	
	/**
	 * TOP R}h.
	 */
	protected static final String COMMAND_TOP = "TOP";
	
	/**
	 * UIDL R}h.
	 */
	protected static final String COMMAND_UIDL = "UIDL";

	/**
	 * 퉞.
	 */
	protected static final String RESPONSE_OK = "+OK";
	
	/**
	 * G[.
	 */
	protected static final String RESPONSE_ERR = "-ERR";
	
	/**
	 * ʏ̔F؃[h(USER/PASS R}hŔF؂sj
	 *
	 * @see #setAuthorizationMode(int)
	 */
	public static final int NORMAL_AUTHORIZATION = 1;
	
	/**
	 * APOPF؃[h.
	 *
	 * @see #setAuthorizationMode(int)
	 */
	public static final int APOP_AUTHORIZATION = 2;
	
	/**
	 * @serial	POP[U. pX[h̓VACYȂ.
	 */
	private String user;
	
	/**
	 * pX[h.
	 * ZLeB̗RÃtB[h transient ł.
	 */
	private transient String password;
	
	/**
	 * @serial	POPT[ozXg.
	 */
	private String host;
	
	/**
	 * @serial	POPT[o|[gԍ.
	 */
	private int port = -1;
	
	/**
	 * @serial	F؃[h. ftHg NORMAL_AUTHORIZATION
	 */
	private int authorizationMode = NORMAL_AUTHORIZATION;
	
	/**
	 * ڑp\Pbg.
	 */
	protected transient Socket socket;

	/**
	 * T[õf[^͗p Stream.
	 */
	protected transient InputStream in;

	/**
	 * T[oւ̃f[^o͗p Stream.
	 */
	protected transient OutputStream out;

	/**
	 * łɃZbVJ݂Ă邩ǂ.
	 */
	protected transient boolean connected = false;
	
	/**
	 * X|Xsǂݍނ߂̃obt@.
	 */
	private transient byte responseBytes[];
	
	/**
	 * ŌɑMR}hɑ΂AT[õXe[^Xs.
	 */
	private transient String status;
	
	/**
	 * ڑɃT[oԂꂽbZ[W(greeting).
	 */
	private transient String greeting;
	
	/**
	 * LIST R}hɑ΂郌X|Xi[z.
	 */
	protected transient String messageList[] = null;
	
	/**
	 * UIDL R}hɑ΂郌X|Xi[z.
	 */
	protected transient String uidList[] = null;
	
	/**
	 * bZ[WM邽߂̓̓Xg[.
	 */
	protected transient POP3MessageInputStream messageInput = null;
	
	/**
	 * @serial fobO[h.
	 */
	private boolean debug;
	
	/**
	 * @serial	^CAEgԁB
	 */
	protected int timeout;
	
	/**
	 * @serial	ڑOɎsR}hB
	 */
	private String preConnectCommand;
	
	/**
	 * ڑ悪m肵ĂȂPOP3Client̃CX^X쐬.
	 */
	public POP3Client() {
		// Ȃ.
	}

	/**
	 * w肳ꂽzXg̃ftHg|[gɐڑ POP3Client̃CX^X쐬.
	 *
	 * @param	host	zXg.
	 * @exception	java.lang.IllegalArgumentException	host  null ̏ꍇ.
	 */
	public POP3Client(String host) {
		this(host, DEFAULT_POP3_PORT);
	}

	/**
	 * w肳ꂽzXgA|[gɐڑ POP3Client̃CX^X쐬.
	 *
	 * @param	host	zXg.
	 * @param	port	|[gԍ.
	 * @exception	java.lang.IllegalArgumentException	host  null ̏ꍇ.
	 */
	public POP3Client(String host, int port) {
		setHost(host);
		setPort(port);
	}
	
	/**
	 * fobObZ[Wo͂.
	 * fobObZ[W̏o͐́ASystem.err ł.
	 *
	 * @param	msg	o̓bZ[W.
	 */
	protected void debugOut(String msg) {
		if (debug) {
			StringBuffer buff = new StringBuffer("DEBUG:");
			buff.append(msg);
			System.err.println(buff.toString());
		}
	}
	
	public void setDebug(boolean mode) {
		this.debug = mode;
	}
	
	public boolean getDebug() {
		return debug;
	}
	
	/**
	 * T[õX|XPsǂݍ.
	 * CRLF ܂łPsƂ݂Ȃ.
	 *
	 * @return	T[õX|Xisj.<BR>
	 *          AsCRLF͎菜ꂽ̂Ԃ.
	 * @exception java.io.IOException	IOG[ꍇ.
	 */
	protected synchronized String readResponseLine() throws IOException {
		boolean cr = false;
		int i;
		for (i = 0; i < responseBytes.length; ++i) {
			int c = in.read();
			if (c == -1) {
				break;
			}
			responseBytes[i] = (byte) c;
			if (responseBytes[i] == CR) {
				cr = true;
			} else if (responseBytes[i] == LF && cr == true) {
				break;
			} else {
				cr = false;
			}
		}
		return new String(responseBytes, 0, i - 1, ENCODE);
	}
	
	/**
	 * T[oƂTCP/IPڑJ݂.
	 * T[oڑ\Pbg쐬AʐMp̃Xg[.<BR>
	 *
	 * @exception	java.io.IOException	IOG[ꍇ.
	 * @exception	java.lang.IllegalStateException	łɃT[o֐ڑĂꍇ.
	 */
	protected synchronized void openConnection() throws IOException {
System.out.println("[openConnection]");
		if (isConnected()) {
			throw new IllegalStateException("Already connected.");
		}
		String cmd = getPreConnectCommand();
		if (cmd != null) {
			debugOut("Execute preconnect command:" + cmd);
			try {
				Runtime runtime = Runtime.getRuntime();
				Process process = runtime.exec(cmd);
				process.waitFor();
				debugOut("Preconnect command done.");
			} catch (InterruptedException ie) {
				throw new InterruptedIOException(ie.getMessage());
			}
		}
		socket = new Socket(getHost(), (getPort() == -1) ? DEFAULT_POP3_PORT : getPort());
		socket.setSoTimeout(getTimeout());
		in = new BufferedInputStream(socket.getInputStream());
		out = new BufferedOutputStream(socket.getOutputStream());
		if (responseBytes == null) {
			responseBytes = new byte[MAX_LINE_LENGTH];
		}
		status = readResponseLine();
		greeting = status;
		connected = true;
System.out.println("[connected=true]");
		debugOut("S:" + greeting);
	}
	
	/**
	 * T[oƂTCP/IPڑؒfA\PbgN[Y.
	 *
	 * @exception java.io.IOException	IOG[ꍇ.
	 */
	protected synchronized void closeConnection() throws IOException {
		try {
			socket.close();
		} finally {
			socket = null;
			in = null;
			out = null;
			status = null;
			greeting = null;
			connected = false;
System.out.println("[connected=false]");
		}
	}

	/**
	 * T[oɃR}h𑗐M.
	 * T[oɃR}h𑗐MAX|XAĂ܂ŃubN.
	 * bZ[WMɂ̃\bhĂяoꍇAbZ[W̎M
	 * ~AR}hM.
	 *
	 * @param	command	R}h.
	 * @return	T[ỏOKłꍇ true. ȊȌꍇ false.
	 * @exception java.io.IOException IOG[ꍇ.
	 */
	protected synchronized boolean sendCommand(String command) throws IOException {
		// bZ[WM𒆎~.
		if (messageInput != null) {
			messageInput.close();
			messageInput = null;
		}
		debugOut("C:" + command);
		byte data[] = command.getBytes(ENCODE);
		out.write(data, 0, data.length);
		out.write(CR);
		out.write(LF);
		out.flush();
		status = readResponseLine();
		debugOut("S:" + status);
		return isStatusOK();
	}

	/**
	 * bZ[WXg.
	 * T[o LIST R}h𑗐MAMXgoϐɕۊǂ.<BR>
	 *
	 * @exception	jp.gr.java_conf.roadster.net.pop.POP3NegativeResponseException	LISTR}hMŃG[ꍇ.
	 * @exception	java.io.IOException	IOG[ꍇ.
	 */
	protected synchronized void initList() throws POP3NegativeResponseException, IOException {
		if (sendCommand(COMMAND_LIST)) {
			Vector tmplist = new Vector();
			String line = readResponseLine();
			while (! ".".equals(line)) {
				tmplist.addElement(line);
				line = readResponseLine();
			}
			messageList = new String[tmplist.size()];
			tmplist.copyInto(messageList);
		} else {
			messageList = null;
			throw new POP3NegativeResponseException(getStatusString());
		}
	}
	
	/**
	 * UID(unique-id)Xg.
	 * T[o UIDL R}h𑗐MAMXgoϐɕۊǂ.<BR>
	 *
	 * @exception	jp.gr.java_conf.roadster.net.pop.POP3NegativeResponseException	LISTR}hMŃG[ꍇ.
	 * @exception	java.io.IOException	IOG[ꍇ.
	 */
	protected synchronized void initUIDList() throws POP3NegativeResponseException, IOException {
		if (sendCommand(COMMAND_UIDL)) {
			Vector tmplist = new Vector();
			String line = readResponseLine();
			while (! ".".equals(line)) {
				tmplist.addElement(line);
				line = readResponseLine();
			}
			uidList = new String[tmplist.size()];
			tmplist.copyInto(uidList);
		} else {
			uidList = null;
			throw new POP3NegativeResponseException(getStatusString());
		}
	}

	/**
	 * w肵ʒu̎MbZ[WXg𓾂.
	 * ́̕AT[o LIST R}h𑗂ۂ̖߂lł.<BR>
	 * Ⴆ΁Aȉ̂悤ȕ񂪕Ԃ.
	 * <UL>
	 *   3  4231<BR>
	 * </UL>
	 *
	 * @param	pos	LIST̈ʒu.
	 * @return	w肳ꂽXg.
	 * @exception	java.io.IOException	IOG[ꍇ.
	 */
	protected synchronized String getListItem(int pos) throws IOException {
		if (messageList == null) {
			initList();
		}
		return new String(messageList[pos]);
	}
	
	/**
	 * SĂ̎MbZ[WXg𓾂.
	 * ́̕AT[o LIST R}h𑗂ۂ̖߂lł.<BR>
	 * Ⴆ΁Aȉ̂悤ȕ񂪕Ԃ.
	 * <UL>
	 *   <CODE>
	 *   String ret[] = client.getListItems();<BR>
	 *   ret[0] -> "1 23435"<BR>
	 *   ret[1] -> "2 4352"<BR>
	 *   ret[2] -> "3 45454"<BR>
	 *   </CODE>
	 * </UL>
	 *
	 * @return	MbZ[WXg̔z.
	 * @exception	java.io.IOException	IOG[ꍇ.
	 */
	protected synchronized String[] getListItems() throws IOException {
		if (messageList == null) {
			initList();
		}
		String ret[] = new String[messageList.length];
		for (int i = 0; i < ret.length; ++i) {
			ret[i] = new String(messageList[i]);
		}
		return ret;
	}

	/**
	 * POP [Uݒ肷.
	 * łɐڑmĂꍇɌĂяoƁAIllegalStateExceptionthrow.
	 *
	 * @param	user	[U.
	 * @exception	java.lang.IllegalStateException	T[o֐ڑĂꍇ.
	 */
	public synchronized void setUser(String user) {
		if (isConnected()) {
			throw new IllegalStateException("Already connected.");
		}
		this.user = user;
	}
	
	/**
	 * POP [U擾.
	 *
	 * @return	POP[U.
	 */
	public synchronized String getUser() {
		return user;
	}
	
	/**
	 * pX[hݒ肷.
	 * nullw肵ꍇɂ̓pX[hƂ݂Ȃ.
	 *
	 * @param	password	pX[h.
	 * @exception	java.lang.IllegalStateException	T[o֐ڑĂꍇ.
	 */
	public synchronized void setPassword(String password) {
		if (isConnected()) {
			throw new IllegalStateException("Already connected.");
		}
		if (password == null) {
			password = "";
		}
		this.password = password;
	}
	
	/**
	 * pX[h擾.
	 *
	 * @return	pX[h.
	 */
	public synchronized String getPassword() {
		return password;
	}
	
	/**
	 * F؃[hݒ肷.
	 *
	 * @param	mode	F؃[h.<BR>
	 *                  NORMAL_AUTHORIZATION ܂ APOP_AUTHORIZATION w肷.
	 */
	public void setAuthorizationMode(int mode) {
		authorizationMode = mode;
	}
	
	/**
	 * F؃[h𓾂.
	 *
	 * @return	F؃[h. NORMAL_AUTHORIZATION ܂ APOP_AUTHORIZATION.
	 */
	public int getAuthorizationMode() {
		return authorizationMode;
	}
	
	/**
	 * POPT[ozXgݒ肷.
	 *
	 * @param	host	POPT[ozXg.
	 * @exception	java.lang.IllegalArgumentException	host  null ̏ꍇ.
	 * @exception	java.lang.IllegalStateException	T[o֐ڑĂꍇ.
	 */
	public void setHost(String host) {
		if (host == null) {
			throw new IllegalArgumentException("host == null.");
		}
		if (isConnected()) {
			throw new IllegalStateException("Already connected.");
		}
		this.host = host;
	}
	
	/**
	 * POPT[ozXg擾.
	 *
	 * @return	POPT[ozXg.
	 */
	public synchronized String getHost() {
		return host;
	}
	
	/**
	 * POPT[o|[gԍݒ肷.
	 * ftHg̃|[gԍύXꍇɂ̂݌Ăяo.
	 *
	 * @param	port	POPT[o|[gԍ. -1 ̏ꍇftHg|[gӖ.
	 * @exception	java.lang.IllegalArgumentException	port < -1 ̏ꍇ.
	 * @exception	java.lang.IllegalStateException	T[o֐ڑĂꍇ.
	 */
	public synchronized void setPort(int port) {
		if (port < -1) {
			throw new IllegalArgumentException("port < -1.");
		}
		if (isConnected()) {
			throw new IllegalStateException("Already connected.");
		}
		this.port = port;
	}

	/**
	 * POPT[o|[gԍ擾.
	 *
	 * @return	POPT[o|[gԍ. -1 ̏ꍇ̓ftHg̃|[ggp.
	 */
	public synchronized int getPort() {
		return port;
	}
	
	/**
	 * greeting(T[oɐڑۂɍŏɕԂ镶)𓾂.
	 * isConnected() == true ̏ꍇɂ݈̂Ӗ̂lԂ.
	 * F؃[h APOP ̏ꍇ́A̕𗘗p digest 𐶐.
	 *
	 * @return	greeting.
	 */
	protected String getGreeting() {
		return greeting;
	}
	
	/**
	 * APOP  digest 쐬.
	 *
	 * @return	digest .
	 */
	private String createDigest() {
		StringBuffer buff = new StringBuffer();
		try {
			String key = "";
			String g = getGreeting();
			int spos = g.indexOf('<');
			int epos = g.indexOf('>');
			if (spos != -1 && epos != -1 && spos < epos) {
				key = g.substring(spos, epos + 1);
			}
			key = key + getPassword();
			MessageDigest md = MessageDigest.getInstance("MD5");
			byte[] digest = md.digest(key.getBytes(ENCODE));
			for (int i = 0; i < digest.length; ++i) {
				char c = (char) ((digest[i] >> 4) & 0xf);
				if (c > 9) {
					c = (char) ((c - 10) + 'a');
				} else {
					c = (char) (c + '0');
				}
				buff.append(c);
				
				c = (char) (digest[i] & 0xf);
				if (c > 9) {
				    c = (char)((c - 10) + 'a');
				} else {
				    c = (char)(c + '0');
				}
				buff.append(c);
			}
		} catch (NoSuchAlgorithmException nsae) {
			nsae.printStackTrace();
		} catch (UnsupportedEncodingException uee) {
			uee.printStackTrace();
		}
		return buff.toString();
	}

	/**
	 * T[oƂ̐ڑ.
	 * TCP/IPڑJ݂A[U^pX[hgp
	 * OC.
	 *
	 * @exception	POP3AuthenticationFailedException	[UF؂Ɏsꍇ.
	 * @exception	java.io.IOException	IOG[ꍇ.
	 * @exception	java.lang.IllegalStateException	łɃT[o֐ڑĂꍇ.
	 */
	public synchronized void connect() throws POP3AuthenticationFailedException, IOException {
System.out.println("[connect]");
		openConnection();
		
		boolean authorized = false;
		if (isStatusOK()) {
			if (getAuthorizationMode() == APOP_AUTHORIZATION) {
				String digest = createDigest();
				if (sendCommand(COMMAND_APOP + ' ' + getUser() + ' ' + digest)) {
					authorized = true;
				}
			} else {
				if (sendCommand(COMMAND_USER + ' ' + getUser()) && sendCommand(COMMAND_PASS + ' ' + getPassword())) {
					authorized = true;
				}
			}
		}
		if (! authorized) {
			String stat = getStatusString();
			closeConnection();
			throw new POP3AuthenticationFailedException(stat);
		}
		
//TODO sleepQ
//		System.out.println("wait ....");
//		try {
//			Thread.sleep(3000);
//		} catch (InterruptedException e) {
//			e.printStackTrace();
//		}
		
	}
	
	/**
	 * T[oƂ̐ڑ.
	 * QUITR}h𑗐MATCP/IPڑؒf.
	 *
	 * @exception	jp.gr.java_conf.roadster.net.pop.POP3Exception	POP3T[oG[Ԃꍇ.
	 * @exception	java.io.IOException	IOG[ꍇ.
	 */
	public synchronized void disconnect() throws POP3Exception, IOException {
		if (! isConnected()) {
			return;
		}
		try {
			if (sendCommand(COMMAND_QUIT)) {
				closeConnection();
			} else {
				throw new POP3NegativeResponseException(getStatusString());
			}
		} finally {
			messageList = null;
			uidList = null;
		}
	}
	
	/**
	 * T[oƂ̐ڑmĂ邩𓾂.
	 *
	 * @return	T[oƂ̐ڑmĂꍇAtrue.
	 */
	public synchronized boolean isConnected() {
		return connected;
	}

	/**
	 * ŌɑMR}hɑ΂Xe[^X𓾂.
	 *
	 * @return	Xe[^Xs.
	 */
	public synchronized String getStatusString() {
		return status;
	}
	
	/**
	 * ŌɑMR}hɑ΂Xe[^Xnjł邩ǂ𓾂.
	 *
	 * @return	OKłꍇ true.
	 */
	public synchronized boolean isStatusOK() {
		if (status != null && status.startsWith(RESPONSE_OK)) {
			return true;
		}
		return false;
	}
	
	/**
	 * T[o STAT R}h𑗐M.
	 *
	 * @return	ɏꂽꍇ true.
	 * @exception	jp.gr.java_conf.roadster.net.pop.POP3Exception	POP3T[oG[Ԃꍇ.
	 * @exception	java.io.IOException	IOG[ꍇ.
	 */
	public synchronized boolean stat() throws POP3Exception, IOException {
		return sendCommand(COMMAND_STAT);
	}

	/**
	 * T[o NOOP R}h𑗐M.
	 *
	 * @return	ɏꂽꍇ true.
	 * @exception	jp.gr.java_conf.roadster.net.pop.POP3Exception	POP3T[oG[Ԃꍇ.
	 * @exception	java.io.IOException	IOG[ꍇ.
	 */
	public synchronized boolean noop() throws POP3Exception, IOException {
		return sendCommand(COMMAND_NOOP);
	}
	
	/**
	 * T[o RSET R}h𑗐M.
	 *
	 * @return	ɏꂽꍇ true.
	 * @exception	jp.gr.java_conf.roadster.net.pop.POP3Exception	POP3T[oG[Ԃꍇ.
	 * @exception	java.io.IOException	IOG[ꍇ.
	 */
	public synchronized boolean rset() throws POP3Exception, IOException {
		return sendCommand(COMMAND_RSET);
	}

	
	/**
	 * bZ[W̐擾.
	 * STAT R}ȟʂł͂ȂALIST R}hœꂽXg̐
	 * Ԃ.
	 *
	 * @return	MbZ[W.
	 * @exception	jp.gr.java_conf.roadster.net.pop.POP3Exception	POP3T[oG[Ԃꍇ.
	 * @exception java.io.IOException	IOG[ꍇ.
	 */
	public synchronized int getMessageCount() throws POP3Exception, IOException {
		if (messageList == null) {
			initList();
		}
		return messageList.length;
	}
	
	/**
	 * w肳ꂽbZ[W̃TCYiINebgPʁjԂ.
	 * AȂlԂT[o݂邽߁Â悤ȃT[oɐڑꍇɂ
	 * ڈxɂȂȂ.
	 *
	 * @param	pos	bZ[Wԍ.擪̃bZ[W0.
	 * @return	bZ[WTCY.(INebgPʁj.TCYȂꍇɂ-1Ԃ.
	 * @exception	jp.gr.java_conf.roadster.net.pop.POP3Exception	POP3T[oG[Ԃꍇ.
	 * @exception	java.io.IOException IOG[ꍇ.
	 */
	public synchronized int getMessageSize(int pos) throws POP3Exception, IOException {
		String item = getListItem(pos);
		StringTokenizer st = new StringTokenizer(item);
		String num = st.nextToken();
		if (st.countTokens() > 0) {
			String size = st.nextToken();
			return Integer.parseInt(size);
		} else {
			return -1;
		}
	}
	
	/**
	 * w肵bZ[WM邽߂̓̓Xg[擾.
	 * ̓̓Xg[ǂݏof[^́APOPT[oRETRR}hŎM
	 * f[^̂̂łAR[h̕ϊ͍sȂ.<BR>
	 * Aȉ̕ϊ͍s邽߁AǂݏoŏKv͂Ȃ.<BR>
	 * <OL>
	 *  <LI>bZ[WI[̔F (CRLF.CRLF I[Ƃ݂ȂA.CRLF ̓bZ[WɊ܂܂Ȃ)A
	 *  <LI>ssIh̕ϊ (CRLF.. -> CRLF. ɕϊ)
	 * </OL>
	 *
	 * ̐񂩂AbZ[WׂēǂݍނAclose() ܂ŁA
	 * ̃bZ[WǂݍނƂ͂łȂ.
	 * ܂AׂẴbZ[WǂݍޑOɂ̃\bhĂяoƁA
	 * ݂̃bZ[W̓ǂݍ݂͒~.
	 *
	 * @param	pos	MΏۂƂȂ郁bZ[Wԍ.Ԑ擪̃bZ[W 0.
	 * @return	bZ[WMp InputStream.
	 * @exception	jp.gr.java_conf.roadster.net.pop.POP3Exception	POP3T[oG[Ԃꍇ.
	 * @exception	java.io.IOException	IOG[ꍇ.
	 */
	public synchronized InputStream retrieve(int pos) throws POP3Exception, IOException {
		if (messageInput != null) {
			messageInput.close();	// ǂݍ݂𒆎~.
			messageInput = null;
		}
		
		if (messageList == null) {
			initList();
		}
		StringTokenizer tokenizer = new StringTokenizer(getListItem(pos));
		String num = tokenizer.nextToken();
		if (sendCommand(COMMAND_RETR + " " + num)) {
			messageInput = new POP3MessageInputStream(in);
			return messageInput;
		} else {
			throw new POP3NegativeResponseException(getStatusString());
		}
	}
	
	/**
	 * TOP R}h. w肳ꂽs̃bZ[Wf[^ǂݍނ߂ InputStream Ԃ.
	 * ŏɃwb_ԂAŝ݂̍sꂽAbZ[W{Ԃ.
	 *
	 * @param	pos	MΏۂƂȂ郁bZ[Wԍ.Ԑ擪̃bZ[W 0.
	 * @param	number	擾s.
	 * @return	bZ[WMp InputStream.
	 * @exception	jp.gr.java_conf.roadster.net.pop.POP3Exception	POP3T[oG[Ԃꍇ.
	 * @exception	java.io.IOException	IOG[ꍇ.
	 */
	public synchronized InputStream top(int pos, int number) throws POP3NegativeResponseException, IOException {
		if (messageInput != null) {
			messageInput.close();	// ǂݍ݂𒆎~.
			messageInput = null;
		}
		if (messageList == null) {
			initList();
		}
		StringTokenizer tokenizer = new StringTokenizer(getListItem(pos));
		String num = tokenizer.nextToken();
		if (sendCommand(COMMAND_TOP + ' ' + num + ' ' + number)) {
			messageInput = new POP3MessageInputStream(in);
			return messageInput;
		} else {
			throw new POP3NegativeResponseException(getStatusString());
		}
	}
	
	/**
	 * w肳ꂽbZ[W폜.
	 *
	 * @param	pos	bZ[Wԍ.擪̃bZ[W 0.
	 * @return	ɍ폜ꂽꍇ true.
	 * @exception	jp.gr.java_conf.roadster.net.pop.POP3Exception	POP3T[oG[Ԃꍇ.
	 * @exception	java.io.IOException	IOG[ꍇ.
	 */
	public synchronized boolean delete(int pos) throws POP3NegativeResponseException, IOException {
		if (messageList == null) {
			initList();
		}
		StringTokenizer tokenizer = new StringTokenizer(getListItem(pos));
		String num = tokenizer.nextToken();
		return sendCommand(COMMAND_DELE + " " + num);
	}
	
	/**
	 * w肳ꂽbZ[WUID(unique-id)𓾂.
	 *
	 * @param	pos	bZ[W̃CfbNX.
	 * @return	UID.
	 * @exception	jp.gr.java_conf.roadster.net.pop.POP3Exception	POP3T[oG[Ԃꍇ.
	 * @exception	java.io.IOException	IOG[ꍇ.
	 */
	public synchronized String getUID(int pos) throws POP3Exception, IOException {
		if (uidList == null) {
			initUIDList();
		}
		String item = uidList[pos];
		StringTokenizer st = new StringTokenizer(item);
		String num = st.nextToken();
		String uid = st.nextToken();
		return uid;
	}
	
	/**
	 * ^CAEgԂݒ肷B
	 * Ow肵ꍇɂ́A^CAEgȂƂӖB
	 *
	 * @param	timeout	^CAEgԁiPʁF~bj
	 */
	public synchronized void setTimeout(int timeout) {
		this.timeout = timeout;
		if (socket != null) {
			try {
				socket.setSoTimeout(timeout);
			} catch (SocketException se) {
				se.printStackTrace();
			}
		}
	}
	
	/**
	 * ^CAEgԂԂB
	 *
	 * @return	^CAEgԁiPʁF~bj
	 */
	public synchronized int getTimeout() {
		return timeout;
	}
	
	/**
	 * ڑOɎsR}ho^B
	 *
	 * @param	command	T[oƂ̐ڑmOɎsR}hB
	 */
	public synchronized void setPreConnectCommand(String command) {
		this.preConnectCommand = command;
	}
	
	/**
	 * ڑOɎsR}hԂB
	 *
	 * @return	ڑOɎsR}hB݂ȂꍇnullB
	 */
	public String getPreConnectCommand() {
		return preConnectCommand;
	}
	
	/**
	 * bZ[Wǂݍݗp̓̓Xg[.
	 * CRLF.CRLF܂łǂݍ.<BR>
	 * CRLF..CRLF  CRLF.CRLFƕϊ.
	 */
	protected class POP3MessageInputStream extends InputStream {
		
		/**
		 * ǂ݃obt@.
		 */
		private final int PRE_READ_LENGTH = 4;
		private byte tmpbuff[] = new byte[PRE_READ_LENGTH];
		
		/**
		 * ǂ݂s߂ɁAPushbackInputStream gp.
		 */
		protected PushbackInputStream pin;
		
		/**
		 * ̂PoCgŏIoCgH
		 */
		protected boolean finalByte = false;

		/**
		 * ȏǂݍ߂ȂԂH
		 */
		protected boolean eof = false;
		
		
		/**
		 * bZ[WǂݍݗpInputStream쐬.
		 * @param	in	ǂݍ݌ƂȂ鉺ʂ̃Xg[.<BR>
		 *              ɓǂݍރoCgAbZ[W̐擪ł邱.
		 */
		public POP3MessageInputStream(InputStream in) {
			this.pin = new PushbackInputStream(in, PRE_READ_LENGTH * 2);
		}
		
		/**
		 * bZ[W̓ePoCgǂݍ.
		 * RFC1939ɊÂACRLF.CRLF o_ŁAbZ[W̏I[Ɣf.<BR>
		 * ܂ACRLF.. ́A CRLF. ɕϊ.
		 *
		 * @return	ǂݍ񂾃oCgBAbZ[W .CRLF ͊܂܂Ȃ.
		 *          ǂݍރf[^Ȃꍇɂ -1.
		 * @exception	java.io.IOException	IOG[ꍇ.
		 */
		public synchronized int read() throws IOException {
			int ret;
			if (eof == true) {
				return -1;		// ʂ̃Xg[ǂݍ܂A -1 Ԃ.
			} else {
				ret = pin.read();
				if (ret == -1 || finalByte == true) {
					eof = true;
					return ret;
				}
			}
			
			byte b = (byte) ret;
			if (b == CR) {
				
				// CR oA㑱̂SoCgǂ݂.
				//
				//  㑱̂SoCg
				// LF.CRLF
				// łꍇAfinalByte  true ɂĂALF unread() .
				// (PushbackInputStream#unread(-1) ҂Ȃ߁A
				//  -1  unread() łȂ.)
				//
				//  㑱̂SoCg
				// LF..
				// łꍇ́ACRLF.. -> CRLF. ϊs߁A
				// LF  .  unread() .
				//
				//  LȊȌꍇɂ́AXg[̏Ԃɖ߂߁A
				// SoCgׂĂ̂܂ unread() .
				for (int i = 0; i < tmpbuff.length; ++i) {
					int c = pin.read();
					if (c == -1) {
						throw new EOFException();
					}
					tmpbuff[i] = (byte) c;
				}
				boolean needsUnread = true;
				if (tmpbuff[0] == LF && tmpbuff[1] == 46) {
					if (tmpbuff[2] == CR && tmpbuff[3] == LF) {	// LF.CRLF
						finalByte = true;
						pin.unread(LF);			
						needsUnread = false;	
						// ̎_ŁAXg[̓e
						// { LF, -1 }
						// ƂȂ.
					} else if (tmpbuff[2] == 46) {				// LF ..
						pin.unread(tmpbuff[3]);	// ]ɓǂł܂ unread() .
						pin.unread(46);
						pin.unread(LF);
						needsUnread = false;
						// ̎_ŁAXg[̓e
						// { LF, '.', tmpbuff[3], ... }
						// ƂȂ.
					}
				}
				if (needsUnread == true) {
					pin.unread(tmpbuff, 0, tmpbuff.length);	// ǂݍޑOƓԂɖ߂.
				}
			}
			return ret;
		}
		
		/**
		 * ̓Xg[ close() .
		 * T[oAbZ[Wf[^Ō܂œǂݍŃ^[.
		 * ǂ݂̃bZ[Wׂēǂݍ܂܂ŃubN.
		 *
		 * @exception	java.io.IOException	IOG[ꍇ.
		 */
		public /* synchronized */ void close() throws IOException {
			int i;
			while ((i = read()) != -1) {
				// ǂݍ񂾃oCĝ͎Ă.
			}
			messageInput = null;	// gւ̎QƂNA.
		}
		
		/**
		 * ubNɓǂݍނƂ̂łoCgԂ.
		 *
		 * @return	ubNɓǂݍނƂ̂łoCg.
		 * @exception	java.io.IOException	IOG[ꍇ.
		 */
		public synchronized int available() throws IOException {
			return pin.available();
		}
	}

	/**
	 * P̎p\bh.
	 * N̈ƂāAzXgAPOPAJEgApX[hw肷
	 * bZ[W̐AbZ[W̓e\.
	 *
	 * @param	args	zXgAPOPAJEgApX[h̏Ɏw肷.
	 * @exception	java.lang.Exception	炩̃G[ꍇ.
	 */
	public static void main(String args[]) throws Exception {
		POP3Client pop = new POP3Client();
		pop.setDebug(true);
		pop.setHost(args[0]);
		pop.setUser(args[1]);
		pop.setPassword(args[2]);
		if (args.length >= 4 && "APOP".equals(args[3])) {
			pop.setAuthorizationMode(POP3Client.APOP_AUTHORIZATION);
		}
//		pop.setPreConnectCommand("ssh -C -f msingh@popserver -L 11110:popserver:110 sleep 5");
//		pop.setPreConnectCommand("rundll32 rnaui.dll,RnaDial Gg");
		pop.connect();
		int count = pop.getMessageCount();
		System.out.println("Message count = " + count);
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		for (int i = 0; i < count; ++i) {
			int messageSize = pop.getMessageSize(i);
			System.out.println("Message size = " + messageSize + " octet.");
			System.out.println("Message UID  = " + pop.getUID(i) + ".");
			InputStream in = pop.retrieve(i);
			int c;
			int bytesRead = 0;
			while ((c = in.read()) != -1) {
				System.out.print((char) c);
				bytesRead++;
			}
			if (bytesRead == messageSize) {
				System.out.println("bytesRead == messageSize");
			} else {
				System.out.println("bytesRead != messageSize");
				System.out.println("\tbytesRead = " + bytesRead);
				System.out.println("\tmessageSize = " + messageSize);
			}
			
			System.out.flush();
			
			System.err.print("Enter TOP command line number > ");
			String line = br.readLine();
			in = pop.top(i, Integer.parseInt(line));
			while ((c = in.read()) != -1) {
				System.out.print((char) c);
			}

			System.err.print("Delete this message ? (y/N) >");
			System.err.flush();
			
			line = br.readLine();
			if ("y".equals(line)) {
				pop.delete(i);
			}
		}
		pop.disconnect();
	}
}
