/*
 * POP3Folder.java
 *
 * Copyright (C) 1998-2000 FreeBeans <freebeans@mub.biglobe.ne.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Copyright (C) 1998-2000N FreeBeans <freebeans@mub.biglobe.ne.jp>
 *
 * {vO̓t[E\tgEFAłBȂ́AFree Software Foundation 
 * \GNU ʌLgṕuo[WQv͂ȍ~̊eo[W
 * ̒炢ꂩIÃo[W߂ɏ]Ė{vO
 * ĔЕz܂͕ύX邱Ƃł܂B
 * {vO͗LpƂ͎v܂AЕzɂẮAsꐫyѓړIK
 * ɂĂ̈Öق̕ۏ؂܂߂āAȂۏ؂sȂ܂BڍׂɂĂ
 * GNU ʌLgpǂ݂B
 *
 * Ȃ́A{vOƈꏏGNU ʌLgp̎ʂ󂯎Ă
 * ͂łBłȂꍇ́AFree Software Foundation, Inc., 675 Mass Ave,
 * Cambridge, MA 02139, USA ֎莆ĂB
 */

package jp.gr.java_conf.roadster.net.pop;

import java.io.File;
import java.io.FilenameFilter;

import java.io.IOException;
import java.util.Vector;
import javax.mail.FetchProfile;
import javax.mail.Flags;
import javax.mail.Folder;
import javax.mail.FolderClosedException;
import javax.mail.FolderNotFoundException;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.event.ConnectionEvent;
import javax.mail.event.FolderEvent;
import javax.mail.event.MessageChangedEvent;
import javax.mail.internet.InternetHeaders;

/**
 * POP3tH_NX.
 */
public class POP3Folder extends Folder {

	/**
	 * tH_̃^Cv.
	 * tH_̃^Cv͌Œi=HOLDS_FOLDERS | HOLDS_MESSAGESj
	 *
	 * Folder type. Type of folder is fixed (HOLDS_FOLDERS | HOLDS_MESSAGES)
	 */
	protected static final int FOLDER_TYPE = HOLDS_FOLDERS | HOLDS_MESSAGES;
	
	/**
	 * tH_̃tl[.
	 * Fullname of this folder.
	 */
	protected String fullName;
	
	/**
	 * f[^ۑfBNg.
	 * Local directory stores messages.
	 */
	protected File dataDirectory;
	
	/**
	 * tH_I[vĂ邩ǂ.
	 * Is folder opened?
	 */
	protected boolean opened = false;
	
	/**
	 * bZ[WLbV.
	 * x쐬 Message IuWFNgLbV.
	 * FePOP3FolderCX^XƗLbVĂ邽߁A
	 * tH_ԂŃLbV̕sv.ǂ̂悤ɓƂ邩̉ۑ.
	 *
	 * Message cache.
	 */
	protected Vector messageCache;
	
	/**
	 * MessageIndex.
	 */
	protected MessageIndex messageIndex;

	/**
	 * Zp[^.(='/')
	 * Separator char (='/')
	 */
	protected static final char SEPARATOR_CHAR = '/';
	
	/**
	 * Zp[^.(="/")
	 * Separator string (="/")
	 */
	protected static final String SEPARATOR = "/";

	/**
	 * Permanent FlagsB
	 */
	private static final Flags permanentFlags = new Flags();
	static {
		permanentFlags.add(Flags.Flag.ANSWERED);
		permanentFlags.add(Flags.Flag.DELETED);
		permanentFlags.add(Flags.Flag.DRAFT);
		permanentFlags.add(Flags.Flag.FLAGGED);
		permanentFlags.add(Flags.Flag.RECENT);
		permanentFlags.add(Flags.Flag.SEEN);
		permanentFlags.add(Flags.Flag.USER);
	}
	
	/**
	 * w肳ꂽO POP3Folder ̃CX^X쐬.
	 * Create a POP3Folder instance which has specified name.
	 *
	 * @param	store		POP3Store.
	 * @param	fullName	̃tH_̃tl[.tl[[ۑfBNgɂȂ.<br>
	 *                      Fullname of this folder. It is equals to local directory name.
	 */
	protected POP3Folder(POP3Store store, String fullName) throws MessagingException {
		super(store);
		this.fullName = fullName;
		this.dataDirectory = new File(store.getRootDirectory(),
								fullName.replace(SEPARATOR_CHAR, File.separatorChar));
		messageIndex = MessageIndex.getInstance(this.dataDirectory);
		initMessageCache();
		store.receiveMessages(this, POP3Store.RECEIVING_ACTION_INIT);
	}
	
	/**
	 * ̃tH_̖OԂ.
	 * fBNg̃tH_ł.
	 *
	 * @return	tH_.
	 */
	public String getName() {
		return dataDirectory.getName();
	}

	/**
	 * ̃tH_̃tl[Ԃ.
	 *
	 * @return	̃tH_̃tl[.
	 */
	public String getFullName() {
		return fullName;
	}

	/**
	 * ̃tH_̐eԂ.
	 * 
	 * @return	etH_.
	 * @exception MessagingException G[ꍇ.
	 */
	public Folder getParent() throws MessagingException {
//		char sep = getSeparator();
		// L̍śÃtH_݂ȂꍇFolderNotFoundException Ă܂B
		// ̃\bh́AtH_݂Ȃꍇɂɓ삷KvB
		
		char sep = SEPARATOR_CHAR;
		int last = fullName.lastIndexOf(sep);
		if (last != -1) {
			return store.getFolder(fullName.substring(0, last));
		} else {
			return store.getDefaultFolder();
		}
	}

	/**
	 * tH_݂邩Ԃ.
	 *
	 * @return	tH_݂ꍇ true.
	 * @exception MessagingException G[ꍇ.
	 */
	public boolean exists() throws MessagingException {
		return dataDirectory.exists();
	}
	
	/**
	 * TutH_Ԃ.
	 *
	 * @param	pattern	p^[.݂̎ł %  * ͖.
	 *                  OƂāA"%" ͑SẴtH_Ƃ݂Ȃ.
	 * @return	z̃tH_.
	 * @exception javax.mail.MessagingException G[ꍇ.
	 */
	public Folder[] list(String pattern) throws MessagingException {
		
		// fBNgXg쐬.
		FilenameFilter filter = ((POP3Store) getStore()).getFilenameFilter(pattern);
		String dirlist[] = dataDirectory.list(filter);
		
		// tH_̃Xg쐬.
		Folder folders[] = new Folder[dirlist.length];
		for (int i = 0; i < folders.length; ++i) {
			folders[i] = store.getFolder(createFullName(getFullName(), dirlist[i]));
		}
		return folders;
	}
	
	/**
	 * subscribed tH_Ԃ.
	 *
	 * @param	pattern	p^[.݂̎ł͖.
	 * @return	z̃tH_.
	 * @exception javax.mail.MessagingException G[ꍇ.
	 */
	public Folder[] listSubscribed() throws MessagingException {
		return super.listSubscribed();
	}

	/**
	 * Zp[^Ԃ.
	 *
	 * @return	File.separatorChar.
	 * @exception javax.mail.FolderNotFoundException	̃tH_݂Ȃꍇ.
	 */
	public char getSeparator() throws MessagingException {
		if (! exists()) {
			throw new FolderNotFoundException(getFullName(), this);
		}
		return SEPARATOR_CHAR;
	}

	/**
	 * ̃tH_̃^CvԂ.
	 * POP3tH_́Aɓ̃tOԂ.
	 *
	 * @return	HOLDS_MESSAGES | HOLDS_FOLDERS
	 * @exception javax.mail.MessagingException G[ꍇ.
	 */
	public int getType() throws MessagingException {
		return FOLDER_TYPE;
	}

	/**
	 * ̃tH_쐬.
	 *
	 * @param	type	.
	 * @return	tH_̍쐬ɐꍇ true.
	 * @exception javax.mail.MessagingException	G[ꍇ.
	 */
	public boolean create(int type) throws MessagingException {
		boolean result = false;
		if (! exists()) {
			try {
				result = dataDirectory.mkdirs();
				if (result) {
					notifyFolderListeners(FolderEvent.CREATED);
				}
			} catch (SecurityException se) {
				throw new MessagingException("SecurityException", se);
			}
		}
		return result;
	}
	
	/**
	 * Subscribed tH_ł邩Ԃ.
	 * 
	 * @return	subscribed tH_łꍇ true.
	 */
	public boolean isSubscribed() {
		return super.isSubscribed();
	}
	
	/**
	 * Subscribe ݒ肷.
	 * iPɖj
	 *
	 * @param	subscribe	subscribe
	 */
	public void setSubscribed(boolean subscribe) throws MessagingException {
		// .
	}
	
	/**
	 * VbZ[W邩𓾂.
	 *
	 * @return	݂ꍇ true.
	 * @exception javax.mail.MessagingException	G[ꍇ.
	 */
	public boolean hasNewMessages() throws MessagingException {
		((POP3Store) store).receiveMessages(this, POP3Store.RECEIVING_ACTION_HASNEWMESSAGES);
		return getNewMessageCount() > 0;
	}
	
	/**
	 * VKbZ[W̐Ԃ.
	 *
	 * @return	VKbZ[W.
	 */
	public int getNewMessageCount() throws MessagingException {
		return messageIndex.getNewMessageCount();
	}
	
	/**
	 * ǃbZ[W̐Ԃ.
	 *
	 * @return	ǃbZ[W.
	 */
	public int getUnreadMessageCount() throws MessagingException {
		return messageIndex.getUnreadMessageCount();
	}
	
	/**
	 * w肵ÕTutH_𓾂.
	 * tH_̐擪 / łꍇɂ́A΃tH_Ƃ݂Ȃ.
	 * tH_̐擪 / ȊȌꍇɂ́A΃tH_Ƃ݂Ȃ.
	 *
	 * @param	name	tH_.
	 * @return	w肳ꂽO Folder IuWFNg.
	 * @exception javax.mail.MessagingException	G[ꍇ.
	 */
	public Folder getFolder(String name) throws MessagingException {
		if (name.length() > 0 && name.charAt(0) == SEPARATOR_CHAR) {
			return store.getFolder(name);
		}
		String basename = getFullName();
		if (! basename.endsWith(SEPARATOR)) {
			basename = basename + SEPARATOR_CHAR;
		}
		return store.getFolder(basename + name);
	}

	/**
	 * ̃tH_폜.
	 *
	 * @param	recurse	truȅꍇAz̃tH_ċAIɍ폜.
	 * @return	tH_폜ꍇ true.
	 * @exception javax.mail.FolderNotFoundException	tH_݂Ȃꍇ.
	 * @exception java.lang.IllegalStateException	tH_I[vĂꍇ.
	 * @exception javax.mail.MessagingException	LȊÕG[ꍇ.
	 */
	public synchronized boolean delete(boolean recurse) throws MessagingException {
		
		if (! exists()) {
			throw new FolderNotFoundException();
		}
		if (isOpen()) {
			throw new IllegalStateException("Folder is opend.");
		}
		if ("INBOX".equalsIgnoreCase(getFullName())) {
			throw new MessagingException("INBOX could not be deleted.");
		}
		
		boolean result = true;
		initMessageCache();
		if (! messageIndex.removeAll()) {
			result = false;
		}

		// TutH_邩𒲂ׂ.
		Folder folders[] = list();
		if (recurse) {	// TutH_폜.
			for (int i = 0; i < folders.length; ++i) {
				if (! folders[i].delete(true)) {
					result = false;
				}
			}
			if (! dataDirectory.delete()) {	// g폜.
				result = false;
			}
		} else {		// TutH_͍폜Ȃ.
			if (folders.length == 0) {			// TutH_݂ȂꍇA
				if (! dataDirectory.delete()) {	// g폜.
					result = false;
				}
			}
		}
		if (result) {
			notifyFolderListeners(FolderEvent.DELETED);
		}
		StringBuffer dbgmsg = new StringBuffer("POP3Folder.delete():");
		dbgmsg.append(getFullName());
		if (result) {
			dbgmsg.append("success.");
		} else {
			dbgmsg.append("failed.");
		}
		((POP3Store) store).debugOut(dbgmsg.toString());
		return result;
	}
	/**
	 * ̃tH_l[.
	 *
	 * @param	folder	l[̃tH_.POP3Folder ̃CX^Xł邱.
	 * @exception javax.mail.FolderNotFoundException	̃tH_݂Ȃꍇ.
	 * @exception java.lang.IllegalStateException	̃tH_I[vĂꍇ.
	 *                                              ܂́Al[̃tH_łɑ݂Ăꍇ.
	 * @exception java.lang.IllegalArgumentException	 folder  POP3FolderŖꍇ.
	 */
	public synchronized boolean renameTo(Folder folder) throws MessagingException {
		if (! exists()) {
			throw new FolderNotFoundException("renameTo() failed.", this);
		}
		if (isOpen()) {
			throw new IllegalStateException(this + " is open.");
		}
		if (folder.exists()) {
			throw new IllegalStateException("Folder " + folder + " already exists.");
		}
		if (! (folder instanceof POP3Folder)) {
			throw new IllegalArgumentException("(folder instanceof POP3Folder) == false");
		}
		if ("INBOX".equalsIgnoreCase(getFullName())) {
			throw new MessagingException("INBOX could not be renamed.");
		}
		File newDataDir = ((POP3Folder) folder).dataDirectory;
		boolean result = dataDirectory.renameTo(newDataDir);
		try {
			if (result) {
				((POP3Folder) folder).messageIndex.reload();
				((POP3Folder) folder).initMessageCache();
				messageIndex.reload();
				initMessageCache();
				notifyFolderRenamedListeners(folder);
			}
		} catch (IOException ioe) {
			throw new MessagingException("IOException", ioe);
		}
		return result;
	}

	/**
	 * ̃tH_I[v.
	 *
	 * @param	mode	I[v[h.
	 * @exception javax.mail.MessagingException	G[ꍇ.
	 */
	public synchronized void open(int mode) throws MessagingException {
		if (! exists()) {
			throw new FolderNotFoundException(getFullName(), this);
		}
		this.mode = mode;		// JavaMail-1.1 ǉ.
		initMessageCache();
		opened = true;
		notifyConnectionListeners(ConnectionEvent.OPENED);
		((POP3Store) store).receiveMessages(this, POP3Store.RECEIVING_ACTION_OPEN);
	}

	/**
	 * ̃tH_.
	 * e ConnectionListener  CLOSED CxgM.
	 * ɕ鎖oȂꍇɂACxg͑M.
	 * 
	 * @param expunge	폜tO̗Ă郁bZ[W폜.
	 * @exception javax.mail.MessagingException	G[ꍇ.
	 */
	public synchronized void close(boolean expunge) throws MessagingException {
		try {
			if (! exists()) {
				throw new FolderNotFoundException(getFullName(), this);
			}
			if (expunge) {
				expunge();
			}
		} finally {
			opened = false;
			messageCache.setSize(1);
			messageIndex.clearRecentFlag();
			
			// OꍇɂCxg͒ʒmB
			notifyConnectionListeners(ConnectionEvent.CLOSED);
		}
	}

	/**
	 * ̃tH_I[vĂ邩ǂԂ.
	 *
	 * @return	I[vĂꍇ true.
	 */
	public boolean isOpen() {
		return opened;
	}
	
	/**
	 * p[}lgtOԂ.
	 * ̃tH_ŃT|[gtO̎ʂԂ.
	 *
	 * @return	̃tH_T|[gtOB
	 */
	public Flags getPermanentFlags() {
		return (Flags) permanentFlags.clone();
	}
	
	/**
	 * tH_̃bZ[WԂ.
	 * JavaMail ̎dlł́AutH_I[vĂȂꍇ -1 
	 * ԂĂ悢vƂȂĂ邪AƖ肪NCAg.
	 * ]āA 0 ȏ̐ԂĂ.
	 *
	 * @return	tH_̃bZ[W.
	 * @exception javax.mail.MessagingException	G[ꍇ.
	 */
	public synchronized int getMessageCount() throws MessagingException {
		return messageCache.size() - 1;
	}
	
	/**
	 * w肳ꂽbZ[WԍɑΉ郁bZ[WIuWFNgԂ.
	 *
	 * @param	msgnum	bZ[Wԍ.
	 * @exception javax.mail.MessagingException	G[ꍇ.
	 */
	public synchronized Message getMessage(int msgnum) throws MessagingException {
		if (! isOpen()) {
			throw new FolderClosedException(this, "msgnum=" + msgnum);
		}
		POP3Message message = (POP3Message) messageCache.elementAt(msgnum);
		if (message == null) {
			message = messageIndex.createMessage(this, msgnum);
			messageCache.setElementAt(message, msgnum);
		}
		return message;
	}
	
	/**
	 * w肳ꂽbZ[Wԍ͈̔͂ɊY
	 * bZ[WIuWFNg𓾂.
	 *
	 * @param	start	Jnԍ.
	 * @param	end		Iԍ.
	 * @return	Ή郁bZ[WIuWFNg.
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	public Message[] getMessages(int start, int end) throws MessagingException {
		return super.getMessages(start, end);
		// ƌ̗ǂ\.
	}
	
	/**
	 * w肳ꂽbZ[WԍɑΉ
	 * bZ[WIuWFNg𓾂.
	 *
	 * @param	msgnums	bZ[Wԍ̔z.
	 * @return	Ή郁bZ[WIuWFNg.
	 * @exception	javax.mail.MessagingException
	 */
	public Message[] getMessages(int[] msgnums) throws MessagingException {
		return super.getMessages(msgnums);
		// ƌ̗ǂ\.
	}
	
	/**
	 * tH_ɂ邷ׂẴbZ[W𓾂.
	 *
	 * @return	tH_̑SbZ[W.
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	public Message[] getMessages() throws MessagingException {
		return super.getMessages();
		// ƌ̗ǂ\.
	}

	/**
	 * bZ[WtH_ɒǉ.
	 * ̃\bh́AtH_N[YĂꍇɂAĂяoƂ
	 * ł.
	 *
	 * @param	msgs	ǉ郁bZ[W̔z.
	 * @exception javax.mail.FolderNotFoundException	tH_݂Ȃꍇ
	 * @exception javax.mail.MessagingException	LȊÕG[ꍇ.
	 */
	public synchronized void appendMessages(Message msgs[]) throws MessagingException {
		if (! exists()) {
			throw new FolderNotFoundException();
		}
		Vector newmsgs = new Vector();
		
		try {
			synchronized (messageIndex) {
				final int startnum = messageIndex.getCount();
				messageIndex.append(msgs);
				final int endnum = messageIndex.getCount();
				for (int i = startnum + 1; i <= endnum; ++i) {
					POP3Message msg = messageIndex.createMessage(this, i);
					newmsgs.addElement(msg);
					messageCache.addElement(msg);
				}
			}
		} finally {
			POP3Message notifymsgs[] = new POP3Message[newmsgs.size()];
			newmsgs.copyInto(notifymsgs);
			notifyMessageAddedListeners(notifymsgs);	// Xiɒʒm.
		}
	}

	/**
	 * bZ[WtFb`.
	 * ͂قƂ IMAP p\bhȂ̂ŁÃNXł͉Ƀ^[.
	 *
	 * @param	msgs	tFb`ΏۂƂȂ郁bZ[WIuWFNg.
	 * @param	fp		tFb`f[^.
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	public void fetch(Message msgs[], FetchProfile fp) throws MessagingException {
	}
	
	/**
	 * w肳ꂽFlagsz̃bZ[Wɐݒ肷B
	 * eMessageChangedListenerMessageChangedCxgʒmB
	 * <br>
	 * eMessageIuWFNg͂̃tH_ɑĂȂ΂Ȃ_ɒӁB
	 * ̃\bhł́AMessageIndex.getFlags(Message) \bhĂяoāÃtO𓾂̂A
	 * flags ̓e𔽉fAMessageIndex.setFlags(Message, Flags) \bhŒlݒ肵ĂB
	 * <br>
	 * dl expunge ꂽbZ[Ww肳ꂽꍇabortĂ͂ȂƂȂĂ邽߁A
	 * zexpungeꂽbZ[W݂ꍇɂ͖悤ɂȂĂB
	 *
	 * @param	msgs	bZ[W̔zBisExpunged() == true ƂȂMessage͖B
	 * @param	flags	ݒΏۂƂȂFlags
	 * @param	value	ݒ肷ꍇ trueB菜ꍇfalseB
	 * @param	javax.mail.MessagingException	tH_I[vĂȂꍇB
	 */
	public void setFlags(Message[] msgs, Flags flags, boolean value) throws MessagingException {
		if (! isOpen()) {
			throw new FolderClosedException(this);
		}
		for (int i = 0; i < msgs.length; ++i) {
			if (msgs[i] instanceof POP3Message) {
				POP3Message message = (POP3Message) msgs[i];
				if (! message.isExpunged()) {
					Flags orgFlags = messageIndex.getFlags(message);
					if (value) {
						orgFlags.add(flags);
					} else {
						orgFlags.remove(flags);
					}
					messageIndex.setFlags(message, orgFlags);
					notifyMessageChangedListeners(MessageChangedEvent.FLAGS_CHANGED, message);
				}
			}
		}
	}
	
	/**
	 * w肳ꂽflagsAbZ[Wԍ start  end ɑΉMessageIuWFNgɐݒ肷B
	 * bZ[Wԍ͂Pn܂邱ƂɒӁB
	 * eMessageChangedListenerMessageChangedCxgʒmB
	 * <br>
	 *
	 * @param	start	ŏ̃bZ[WԍB
	 * @param	end		Ō̃bZ[WԍB
	 * @param	flags	ݒ肷tOB
	 * @param	value	ݒ肷ꍇ true
	 */
	public void setFlags(int start, int end, Flags flags, boolean value) throws MessagingException {
		if (! isOpen()) {
			throw new FolderClosedException(this);
		}
		Message[] msgs = getMessages(start, end);
		setFlags(msgs, flags, value);
	}
	
	/**
	 * w肳ꂽflagsAzŎw肳ꂽbZ[WԍɑΉMessageIuWFNgɐݒ肷B
	 * eMessageChangedListenerMessageChangedCxgʒmB
	 *
	 * @param	msgnums	bZ[Wԍ̔zB
	 * @param	flags	ݒ肷tOB
	 * @param	value	ݒ肷ꍇ true
	 */
	public void setFlags(int[] msgnums, Flags flags, boolean value) throws MessagingException {
		if (! isOpen()) {
			throw new FolderClosedException(this);
		}
		Message[] msgs = getMessages(msgnums);
		setFlags(msgs, flags, value);
	}
	
	/**
	 * 폜tO̗bZ[W폜.
	 *
	 * @return	폜ꂽbZ[W̔z.Az̃bZ[WIuWFNg
	 *          ɑ΂ẮAisExpunged()  getMessageNumber() ȊO
	 *          \bhĂяoȂ.Ăяo MessagingException  throw .
	 * @exception	javax.mail.FolderNotFoundException	tH_݂Ȃꍇ.
	 * @exception	java.lang.IllegalStateException	tH_I[vĂȂꍇ.
	 *              (FolderClosedException̂قǂƎvAJavaMail̎dlł߂Ă)
	 * @exception	javax.mail.MessagingException	LȊÕG[ꍇ.
	 */
	public synchronized Message[] expunge() throws MessagingException {
		if (! exists()) {
			throw new FolderNotFoundException("expunge() failed.", this);
		}
		if (! isOpen()) {
			throw new IllegalStateException(this + " is closed. expunge() failed.");
		}
		
		int newmsgnum = 1;
		final int msgcount = getMessageCount();
		Vector expungedMessages = new Vector();
		for (int i = 1; i <= msgcount; ++i) {
			POP3Message message = (POP3Message) messageCache.elementAt(i);
			if (message != null) {
				if (message.isSet(Flags.Flag.DELETED)) {
					// messageIuWFNg expunged tO true ɂ.
					message.setExpunged(true);
					expungedMessages.addElement(message);
	        	} else {
					// 폜ȂbZ[Wɂ́AVԍt^.
					message.setMessageNumber(newmsgnum);
					newmsgnum++;
				}
			}
		}
	    
		// 폜bZ[W̔z쐬.
		POP3Message msgs[] = new POP3Message[expungedMessages.size()];
		expungedMessages.copyInto(msgs);

		// LbV烁bZ[WIuWFNg폜.
		for (int i = 0; i < msgs.length; ++i) {
			messageCache.removeElement(msgs[i]);
		}
		
		// bZ[Wt@C폜.
		messageIndex.remove(msgs);
		
		// Pʈȏ̃bZ[W폜ꍇ́AXiɒʒm.
		if (msgs.length > 0) {
			notifyMessageRemovedListeners(true, msgs);
		}
		return msgs;
	}
	
	/**
	 * Q̃tH_ԂB
	 *
	 * @param	o	rΏۂƂȂIuWFNgB
	 * @return	ꍇ trueB
	 */
	public boolean equals(Object o) {
		if (o instanceof POP3Folder) {
			POP3Folder folder = (POP3Folder)  o;
			if (folder.getStore() == getStore() && (folder.getFullName().equals(getFullName()))) {
				return true;
			}
		}
		return false;
	}

	//--- ́APOP3Folder ŗL̃\bh.
	
	/**
	 * w肳ꂽbZ[WɑΉ Flags IuWFNgԂ.
	 *
	 * @param	message	bZ[W.
	 * @return	Flags IuWFNg. 
	 */
	protected Flags getMessageFlags(POP3Message message) throws MessagingException {
		return (Flags) messageIndex.getFlags(message);
	}
	
	/**
	 * w肳ꂽbZ[WɑΉ InternetHeaders IuWFNgԂB
	 *
	 * @param	message	bZ[WB
	 * @return	bZ[WɑΉ InternetHeadersB
	 */
	protected InternetHeaders getMessageHeaders(POP3Message message) throws MessagingException {
		return messageIndex.getHeaders(message);
	}
	
	/**
	 * w肳ꂽbZ[Wcontent\ byte[] ԂB
	 *
	 * @param	message	bZ[WB
	 * @return	bZ[W content byte[]B
	 */
	protected byte[] getMessageContentBytes(POP3Message message) throws MessagingException {
		return messageIndex.getContentBytes(message);
	}
	
	/**
	 * ^ꂽetH_Ƒ΃tH_ƂāAtH_̃tl[쐬.
	 *
	 * @param	parent	etH_.
	 * @param	child	΃tH_.
	 * @return	tl[.
	 */
	protected String createFullName(String parent, String child) {
		if (parent == null) {
			return null;
		}
		if (child == null) {
			return parent;
		}
		
		if (parent.startsWith(SEPARATOR)) {
			parent = parent.substring(1);
		}
		if (parent.endsWith(SEPARATOR)) {
			parent = parent.substring(0, parent.length() - 1);
		}
			
		if (child.startsWith(SEPARATOR)) {
			child = child.substring(1);
		}
		if (child.endsWith(SEPARATOR)) {
			child = child.substring(0, child.length() - 1);
		}
		return parent + SEPARATOR + child;
	}
	
	/**
	 * bZ[WLbV.
	 */
	private void initMessageCache() {
		if (messageCache == null) {
			messageCache = new Vector();
		}
		messageCache.setSize(messageIndex.getCount() + 1);
	}
}
