/*
 * SubFolderFilter.java
 *
 * Copyright (C) 2000 FreeBeans <freebeans@mub.biglobe.ne.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Copyright (C) 2000N FreeBeans <freebeans@mub.biglobe.ne.jp>
 *
 * {vO̓t[E\tgEFAłBȂ́AFree Software Foundation 
 * \GNU ʌLgṕuo[WQv͂ȍ~̊eo[W
 * ̒炢ꂩIÃo[W߂ɏ]Ė{vO
 * ĔЕz܂͕ύX邱Ƃł܂B
 * {vO͗LpƂ͎v܂AЕzɂẮAsꐫyѓړIK
 * ɂĂ̈Öق̕ۏ؂܂߂āAȂۏ؂sȂ܂BڍׂɂĂ
 * GNU ʌLgpǂ݂B
 *
 * Ȃ́A{vOƈꏏGNU ʌLgp̎ʂ󂯎Ă
 * ͂łBłȂꍇ́AFree Software Foundation, Inc., 675 Mass Ave,
 * Cambridge, MA 02139, USA ֎莆ĂB
 */

package jp.gr.java_conf.roadster.net.pop;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.io.File;
import java.io.FilenameFilter;

/**
 * TutH_񋓂tB^[B
 */
class SubFolderFilter implements FilenameFilter {
	/**
	 * File.isHidden() \bhB
	 * JDK1.1ɂ݂͑Ȃ߁AڌĂяoReflectiongpĂB
	 */
	private static final Method isHidden;
	static {
		Method test = null;
		try {
			test = File.class.getMethod("isHidden", null);
		} catch (NoSuchMethodException nsme) {
			test = null;
		}
		isHidden = test;
	}
	
	/**
	 * XgAbṽp^[B
	 */
	private String pattern;
	
	/**
	 * BtH_XgAbv邩B
	 */
	private boolean listHidden;
	
	/**
	 * CX^X쐬B
	 *
	 * @param	pattern		p^[BJavaMailFolder.list(String pattern)QƁB
	 * @param	listHidden	Bt@CXgAbv邩B
	 */
	public SubFolderFilter(String pattern, boolean listHidden) {
		this.listHidden = listHidden;
		this.pattern = pattern;
	}
	
	/**
	 * w肳ꂽt@CXgAbvΏۂƂ邩ԂB
	 *
	 * @param	dir
	 * @param	name
	 */
	public boolean accept(File dir, String name) {
		boolean result = false;
		try {
			File file = new File(dir, name);
			if (file.isDirectory()) {
				if (listHidden) {	// Bt@C\B
					result = true;
				} else {			// Bt@C\ȂB
					if (isHidden == null) {
						// File.isHidden() \bh݂Ȃꍇ́A
						// 肪łȂ߁A true ԂB
						result = true;
					} else {
						// File.isHidden() \bhgĔʂB
						Boolean b = (Boolean) isHidden.invoke(file, null);
						if (! b.booleanValue()) {
							result = true;
						}
					}
				}
			}
		} catch (IllegalAccessException iae) {		// 肦Ȃ...
			iae.printStackTrace();
			result = false;
		} catch (InvocationTargetException ite) {	// ߂ɂ肦ȂB
			Throwable t = ite.getTargetException();
			t.printStackTrace();
			result = false;
		}
		if (result) {
			result = match(name);
		}
		return result;
	}

	/**
	 * p^[Ɉv邩𔻒肷B
	 * _ł́A'%'  '%'ȊÔ̕ǂ炩ɂΉĂȂB
	 *
	 * @param	src	r镶B
	 */
	private boolean match(String src) {
		boolean result = false;
		if (pattern.equals("%")) {
			result = true;
		} else {
			if (pattern.equals(src)) {
				result = true;
			}
		}
		return result;
	}
	
	/**
	 * isHidden() \bh݂邩ԂB
	 *
	 * @return	݂ꍇ trueB
	 */
	static boolean isHiddenMethodSupported() {
		return isHidden != null;
	}
}
